
-optimizationpasses 5
-useuniqueclassmembernames
-renamesourcefileattribute SourceFile
-adaptresourcefilenames **.properties
-dontusemixedcaseclassnames
-adaptresourcefilecontents **.properties,META-INF/MANIFEST.MF
-verbose
-ignorewarnings
-dontpreverify

# Keep - Applications. Keep all application classes, along with their 'main'
# methods.
-keepclasseswithmembers public class * {
    public static void main(java.lang.String[]);
}

-keepclasseswithmembers,allowshrinking class * {
    native <methods>;
}
-keepclassmembers enum  * {
    public static **[] values();
    public static ** valueOf(java.lang.String);
}

-keepattributes Exceptions,InnerClasses,Signature,Deprecated,SourceFile,LineNumberTable,*Annotation*,EnclosingMethod,JavascriptInterface

-keep public class * extends android.app.Activity
-keep public class * extends android.content.BroadcastReceiver {*;}

-keep public class  com.hling.sdk.** { *; }
-keep public class  com.hling.core.common.utils.** { *; }
-keep class com.qq.e.** {
    public protected *;
}

-keepclassmembers class * {
    @android.webkit.JavascriptInterface <methods>;
}

-keepclassmembers class * extends android.app.Activity {
public void *(android.view.View);
}
-keepclassmembers enum * {
public static **[] values();
public static ** valueOf(java.lang.String);
}

-keep class package.*.model.**{*;}

## JD
-keep class com.jd.ad.sdk.core.event.CustomAdEvent {*;}
-keep class com.jd.ad.sdk.imp.splash.CustomSplashEvent {*;}
-keep class com.jd.ad.sdk.adapter.TT*

##oaid
-keep class XI.CA.XI.**{*;}
-keep class XI.K0.XI.**{*;}
-keep class XI.XI.K0.**{*;}
-keep class XI.vs.K0.**{*;}
-keep class XI.xo.XI.XI.**{*;}
-keep class com.asus.msa.SupplementaryDID.**{*;}
-keep class com.asus.msa.sdid.**{*;}
-keep class com.bun.lib.**{*;}
-keep class com.bun.miitmdid.**{*;}
-keep class com.huawei.hms.ads.identifier.**{*;}
-keep class com.samsung.android.deviceidservice.**{*;}
-keep class org.json.**{*;}
-keep public class com.netease.nis.sdkwrapper.Utils {public <methods>;}

-keep public class com.halomobi.ssp.sdk.**{*;}
-keep public class com.danikula.videocache.** {*;}
-keep public class com.halomobi.ssp.base.utils.**{*;}
-keep public class com.halomobi.ssp.base.core.common.ConstantPool {*;}
-keep public class  com.halomobi.ssp.base.core.common.NetEnvironment {*;}


-keep class com.umeng.** {*;}
-keep class com.uc.** {*;}
-keepclassmembers class * {
   public <init> (org.json.JSONObject);
}
-keep class com.zui.** {*;}
-keep class com.miui.** {*;}
-keep class com.heytap.** {*;}
-keep class a.** {*;}
-keep class com.vivo.** {*;}

##快手
-keep class org.chromium.** {*;}
-keep class org.chromium.** { *; }
-keep class aegon.chrome.** { *; }
-keep class com.kwai.**{ *; }
-dontwarn com.kwai.**
-dontwarn com.kwad.**
-dontwarn com.ksad.**
-dontwarn aegon.chrome.**

##百度
-ignorewarnings
-dontwarn com.baidu.mobads.sdk.api.**
-keepclassmembers class * extends android.app.Activity {
   public void *(android.view.View);
}

-keepclassmembers enum * {
    public static **[] values();
    public static ** valueOf(java.lang.String);
}

-keep class com.baidu.mobads.** { *; }
-keep class com.style.widget.** {*;}
-keep class com.component.** {*;}
-keep class com.baidu.ad.magic.flute.** {*;}
-keep class com.baidu.mobstat.forbes.** {*;}
-keep class com.bun.miitmdid.core.** {*;}

-keepattributes *Annotation*
-keepclassmembers class ** {
    @org.greenrobot.eventbus.Subscribe <methods>;
}
-keep enum org.greenrobot.eventbus.ThreadMode { *; }
-keepclassmembers class * extends org.greenrobot.eventbus.util.ThrowableFailureEvent {
    <init>(java.lang.Throwable);
}

# inMobi混淆配置
-keepattributes SourceFile,LineNumberTable
-keep class com.inmobi.** { *; } -dontwarn com.squareup.picasso.**
# skip the Picasso library classes
-keep class com.squareup.picasso.** {*;} -dontwarn com.squareup.okhttp.**
# skip Moat classes
-keep class com.moat.** {*;} -dontwarn com.moat.**
# skip IAB classes
-keep class com.iab.** {*;} -dontwarn com.iab.**

#讯飞
-dontwarn com.shu.priory.**
-keep class com.shu.priory.** {* ;}
-keep class android.support.v4.**{public * ;}

-keep class com.fish.entry.FishLoader{ *; }
-keep class com.tencent.tgpa.**{*;}
-keep class com.tencent.klevin.**{*;}

-keepattributes Signature
-keepattributes *Annotation*
-keep class com.mbridge.** {*; }
-keep interface com.mbridge.** {*; }
-keep interface androidx.** { *; }
-keep class androidx.** { *; }
-keep public class * extends androidx.** { *; }
-dontwarn com.mbridge.**
-keep class **.R$* { public static final int mbridge*; }

-keep class com.lenovo.sdk.** { *; }
-dontwarn com.lenovo.sdk.**
-keep class com.lenovo.sdk.BuildConfig { *; }


-keep class com.anythink.**{ *;}
-keep class com.bytedance.**{ *; }
-keep class com.kwad.**{ *; }
-keep class com.baidu.mobads.**{ *; }
-keep class com.qq.e.ads.**{ *; }

# OKHTTP
-keep class okhttp3.** { *; }
-keep interface okhttp3.** { *; }
-dontwarn okhttp3.**
-keep class okio.** { *; }
-keep interface okio.** { *; }
-dontwarn okio.**

# gson
-keep class com.google.gson.**{*;}

-keep public class * extends java.net.** {*;}
-keep public class * extends javax.net.ssl.** {*;}

-keep class com.sntech.**{*;}
-keep class com.sn.**{*;}
-keep class com.uodis.opendevice.aidl.**{*;}
-keep class com.repack.bun.miitmdid.core.** {*;}

-keep class com.lenovo.sdk.** { *; }
-dontwarn com.lenovo.sdk.**

-keep class com.jd.ad.sdk.** { *; }

-keep class * extends android.app.Application
-keep class * extends android.content.ContentProvider

-keep class com.bytedance.sdk.openadsdk.core.**{*;}
-keep class com.bytedance.sdk.openadsdk.multipro.**{*;}
-keep class com.opos.** { *;}
-keep class com.heytap.msp.mobad.** { *;}
-keep class com.heytap.openid.** {*;}

-keep class okio.**{ *; }

-keeppackagenames com.heytap.nearx.tapplugin
-dontwarn com.tapadn.**
-keep class com.tapadn.** { *;}
-dontshrink

-keep public class com.ubix.** { *;}
-keep public class com.ubixnow.** { *;}

#章鱼
-dontwarn com.octopus.ad.**
-keep class com.octopus.ad.** {*;}