package com.hling.demo.AdsView

import android.os.Bundle
import android.view.View
import android.widget.Button
import android.widget.RelativeLayout
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlBannerAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlBannerListener
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R


class BannerActivity : BaseAdActivity() {
    private var bannerContainer: RelativeLayout? = null

    private var hlBannerAd: HlBannerAd? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_banner)
        bannerContainer = findViewById(R.id.bannerContainer)
//        bannerPositionTop(bannerContainer as RelativeLayout)//设置banner在视图顶部
        bannerPositionBottom(bannerContainer as RelativeLayout)//设置banner在视图底部
        val loadBtn = findViewById<Button>(R.id.bt_load)
        val stopBtn = findViewById<Button>(R.id.bt_stop_refresh)
        bannerContainer
        loadBtn.setOnClickListener {
            if (!ActivityUtil.isFastClick) {
                loadBannerAd()
            }
        }
        stopBtn.setOnClickListener {
            hlBannerAd?.stopRefresh()
        }
        
    }


    private fun loadBannerAd() {
        hlBannerAd = HlBannerAd(this, AppConfig.BANNER_ID, hlBannerListener)
        hlBannerAd?.setRefresh(30) //设置自动刷新banner时间
        hlBannerAd?.loadAd()
    }

    private val hlBannerListener: HlBannerListener = object : HlBannerListener {
        override fun onDisplayAd() {
            LogUtils.d("HaloSDKDemo:Banner::onDisplay");
        }

        override fun onClickAd() {
            LogUtils.d("HaloSDKDemo:Banner::onClick");
        }

        override fun onCloseAd() {
            LogUtils.d("HaloSDKDemo:Banner::onClose");
            bannerContainer?.removeAllViews()
        }

        override fun onAdLoadSuccess(view: View?) {
            if (hlBannerAd != null) {
                hlBannerAd?.ecpm //获取当前广告的ecmp价格
                LogUtils.d("HaloSDKDemo:Banner::onAdLoadSuccess：" + "ecpm:" + hlBannerAd?.ecpm);
            }
            bannerContainer?.removeAllViews()
            bannerContainer?.addView(view)
        }

        override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d("HaloSDKDemo:Banner::OnAdFailed::onAdErrorMsg:$msg=onAdErrorCode:$code");
        }
    }


    override fun onDestroy() {
        super.onDestroy()
        if (hlBannerAd != null) {
            hlBannerAd?.release()
            hlBannerAd = null
        }
        if (bannerContainer != null) {
            bannerContainer?.removeAllViews()
            bannerContainer = null
        }
    }


    fun bannerPositionTop(relativeLayout: RelativeLayout) {
        val relativeLayout_Params = RelativeLayout.LayoutParams(
            RelativeLayout.LayoutParams.MATCH_PARENT,
            RelativeLayout.LayoutParams.WRAP_CONTENT
        )
        relativeLayout_Params.addRule(RelativeLayout.ALIGN_PARENT_TOP) // 设置顶部对齐
        relativeLayout.layoutParams = relativeLayout_Params
    }

    fun bannerPositionBottom(relativeLayout: RelativeLayout) {
        val relativeLayout_Params = RelativeLayout.LayoutParams(
            RelativeLayout.LayoutParams.MATCH_PARENT,
            RelativeLayout.LayoutParams.WRAP_CONTENT
        )
        relativeLayout_Params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM) // 设置顶部对齐
        relativeLayout.layoutParams = relativeLayout_Params
    }
}
