package com.hling.demo.AdsView

import android.annotation.SuppressLint
import android.app.Activity
import android.os.Bundle
import android.view.KeyEvent
import android.view.View
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlInterAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlInterListener
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R

class InsertActivity : BaseAdActivity(), View.OnClickListener {
    private var hlInterAd: HlInterAd? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_inter)
        findViewById<View>(R.id.bt_load).setOnClickListener(this)
    }


    @SuppressLint("NonConstantResourceId")
    override fun onClick(view: View) {
        if (view.id == R.id.bt_load) {
            if (!ActivityUtil.isFastClick) {
                loadAd()
            }
        }
    }

    private fun loadAd() {
        hlInterAd = HlInterAd(this, AppConfig.INSERT_ID, hlInterListener)
        hlInterAd?.loadAd()
    }

    private val hlInterListener: HlInterListener = object : HlInterListener {
        override fun onDisplayAd() {
            LogUtils.d("HaloSDKDemo:Inter::onDisplay");
        }

        override fun onClickAd() {
            LogUtils.d("HaloSDKDemo:Inter::onClick");
        }

        override fun onCloseAd() {
            LogUtils.d("HaloSDKDemo:Inter::onClose");
        }

        override fun onAdLoadSuccess() {
            if (hlInterAd != null) {
                hlInterAd?.ecpm
                hlInterAd?.showAd()
                LogUtils.d("HaloSDKDemo:Inter::onAdLoadSuccess:"+"ecpm:"+ hlInterAd?.ecpm);
            }
        }

        override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d("HaloSDKDemo:Inter::onAdErrorMsg:" + msg + "onAdErrorCode:" + code);
        }
    }


    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (event.action == KeyEvent.ACTION_DOWN) {
            onDestroy()
            finish()
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onDestroy() {
        super.onDestroy()
        if (hlInterAd != null) {
            hlInterAd?.release()
            hlInterAd = null
        }
    }
}
