package com.hling.demo.AdsView

import android.annotation.SuppressLint
import android.os.Bundle
import android.view.KeyEvent
import android.view.View
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlFullInterAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlFullinterListener
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R


class InsertFullScreenActivity : BaseAdActivity(), View.OnClickListener {
    private var hlFullInterAd: HlFullInterAd? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_fullinter)
        findViewById<View>(R.id.bt_load).setOnClickListener(this)
    }


    @SuppressLint("NonConstantResourceId")
    override fun onClick(view: View) {
        if (view.id == R.id.bt_load) {
            if (!ActivityUtil.isFastClick) {
                loadAd()
            }
        }
    }

    private fun loadAd() {
        hlFullInterAd = HlFullInterAd(this, AppConfig.INSERT_FUll_ID, hlFullinterListener)
        hlFullInterAd?.loadAd()
    }

    private val hlFullinterListener: HlFullinterListener = object : HlFullinterListener {
        override fun onDisplayAd() {
            LogUtils.d( "HaloSDKDemo:InsertFull::onDisplay");
        }

        override fun onClickAd() {
            LogUtils.d( "HaloSDKDemo:InsertFull::onClick");
        }

        override fun onCloseAd() {
            LogUtils.d( "HaloSDKDemo:InsertFull::onClose");
        }

        override fun onAdLoadSuccess() {
            if (hlFullInterAd != null) {
                hlFullInterAd?.ecpm
                hlFullInterAd?.showAd()
                LogUtils.d("HaloSDKDemo:InsertFull::onAdLoadSuccess:"+"ecpm:"+hlFullInterAd?.ecpm);
            }
        }

        override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d( "HaloSDKDemo:InsertFull::onAdErrorMsg:" + msg + "onAdErrorCode: " + code);
        }
    }


    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (event.action == KeyEvent.ACTION_DOWN) {
            onDestroy()
            finish()
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onDestroy() {
        super.onDestroy()
        if (hlFullInterAd != null) {
            hlFullInterAd?.release()
            hlFullInterAd = null
        }
    }
}
