package com.hling.demo.AdsView

import android.os.Bundle
import android.view.View
import android.widget.Button
import android.widget.FrameLayout
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlNativeAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlNativeListener
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.Jzvd
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R


class NativeActivity : BaseAdActivity() {
    private var mExpressContainer: FrameLayout? = null


    private var hlNativeAd: HlNativeAd? = null

    private var mButtonLightLoadAd: Button? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        // 设置锁屏下可展示，此配置仅限测试调试使用，正式代码慎用
        setContentView(R.layout.activity_native)
        mButtonLightLoadAd = findViewById<View>(R.id.btn_light_load) as Button
        mButtonLightLoadAd?.setOnClickListener(mClickListener)
        mExpressContainer = findViewById<View>(R.id.express_container) as FrameLayout
    }

    private val mClickListener =
        View.OnClickListener { v: View ->
            if (v.id == R.id.btn_light_load) {
                if (!ActivityUtil.isFastClick) {
                    loadExpressAd()
                }
            }
        }

    private fun loadExpressAd() {
        hlNativeAd = HlNativeAd(
            this,
            AppConfig.NATIVE_ID,
            2,
            hlNativeListener
        ) //directionType:1.左图右文 2.左文右图 3.上图下文 4.纯图
        hlNativeAd?.loadAd()
    }



    private val hlNativeListener: HlNativeListener = object : HlNativeListener {
        override fun onAdLoadSuccess(view: View?) {
            if (hlNativeAd != null) {
                val ecpm = hlNativeAd?.ecpm
                LogUtils.d("HaloSDKDemo:Native::onAdLoadSuccess:ecpm:$ecpm");
            }
            mExpressContainer?.removeAllViews()
            mExpressContainer?.addView(view)
        }

        override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d("HaloSDKDemo:Native::onAdErrorMsg:" + msg + "onAdErrorCode:" + code);
        }

        override fun onAdShow(view: View?) {
            LogUtils.d("HaloSDKDemo:Native::onAdShow");
        }

        override fun onAdClick(view: View?) {
            LogUtils.d("HaloSDKDemo:Native::onAdClick");
        }

        override fun onAdClose(view: View?) {
            LogUtils.d("HaloSDKDemo:Native::onAdClose");
            mExpressContainer?.removeAllViews()
        }
    }

    override fun onPause() {
        super.onPause()
    }

    override fun onResume() {
        super.onResume()
    }

    override fun onDestroy() {
        super.onDestroy()
        if (hlNativeAd != null) {
            hlNativeAd?.release()
            hlNativeAd=null
        }
        if (mExpressContainer != null) {
            mExpressContainer?.removeAllViews()
            mExpressContainer=null
        }
    }
}
