package com.hling.demo.AdsView

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.hardware.Sensor
import android.hardware.SensorEvent
import android.hardware.SensorEventListener
import android.hardware.SensorManager
import android.os.Bundle
import android.text.TextUtils
import android.util.DisplayMetrics
import android.view.LayoutInflater
import android.view.View
import android.view.WindowManager
import android.widget.Button
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.base.utils.ToolsUtils
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeResponse
import com.halomobi.ssp.bussiness.module_sdk.manager.HlUnifiedNativeAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlUnifiedNativeListener
import com.halomobi.ssp.bussiness.module_sdk.normal.RadiusImageView
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JzvdStd
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener
import com.halomobi.ssp.model.request.bean.AdBean
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R
import kotlin.math.abs

class NativeUnifiedActivity : BaseAdActivity() {
    private var mUnifiedNativeAdView: UnifiedNativeAdView? = null


    private var response: NativeResponse? = null

    private var hlUnifiedNativeAd: HlUnifiedNativeAd? = null

    private var inflate: View? = null

    private var iv_shake: ImageView? = null
    private var uniFiedNativeView: UnifiedNativeView? = null

    private var isShow: Boolean = false
    private var sensorManager: SensorManager? = null
    private var accelerometer: Sensor? = null

    private var lastUpdate: Long = 0
    private var lastX = 0f
    private var lastY = 0f
    private var lastZ = 0f

    private var imageViews: Array<ImageView>? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_unified_native)
        val btLoad = findViewById<Button>(R.id.bt_load)
        mUnifiedNativeAdView = findViewById(R.id.unified_native)
        btLoad.setOnClickListener { v: View? ->
            if (!ActivityUtil.isFastClick) {
                loadUnifiedNativeAd()
            }
        }
    }

    private fun loadUnifiedNativeAd() {
        hlUnifiedNativeAd =
            HlUnifiedNativeAd(this, AppConfig.NATIVE_UNIFIED_ID, hlUnifiedNativeListener)
        hlUnifiedNativeAd?.loadAd()
    }


    private inner class UnifiedNativeView(context: Context) : RelativeLayout(context) {
        init {
            isShow = false
            inflate = LayoutInflater.from(context).inflate(
                R.layout.hj_native_item_imag_left,
                this
            )
            sensorManager = context.getSystemService(SENSOR_SERVICE) as SensorManager
            accelerometer = sensorManager?.getDefaultSensor(Sensor.TYPE_ACCELEROMETER)
            sensorManager?.registerListener(
                sensorEventListener,
                accelerometer,
                SensorManager.SENSOR_DELAY_NORMAL
            )
        }

        @SuppressLint("CutPasteId")
        fun showView(parseData: List<NativeResponse?>?) {
            response = parseData?.get(0)
            val relayout = inflate?.findViewById<RelativeLayout>(R.id.relativelayout)
            var imageView: View? = inflate?.findViewById<RadiusImageView>(R.id.iv_cion1)
            iv_shake = inflate?.findViewById(R.id.iv_shake)
            val tv_item_linear = inflate?.findViewById<LinearLayout>(R.id.tv_item_linear)
            val iv_close = inflate?.findViewById<ImageView>(R.id.iv_close)
            val title = inflate?.findViewById<TextView>(R.id.tv_item_title)
            val subTitle = inflate?.findViewById<TextView>(R.id.tv_item_details)
            val logo_item_linear = inflate?.findViewById<LinearLayout>(R.id.logo_item_linear)
            title?.textSize = 14f
            subTitle?.textSize = 12f

            //左图右文
            relayout?.layoutParams =
                LayoutParams(
                    Utils.getScreenSize(true)[0],
                    Utils.getScreenSize(true)[1].div(7)
                )//获取屏幕宽高 单位:px
            when (response?.adInfo?.creative_type) {
                AdBean.CRE_TYPE_IMAGE -> {
                    imageView?.layoutParams = relayout?.layoutParams?.width?.div(2)
                        ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                    response?.setImageBindDataProxy { imageUrls ->
                        imageViews = arrayOf((imageView as ImageView)) // 使用自定义网络图片加载框架
                        if (imageUrls != null) {
                            for (i in imageUrls.indices) {
                                response?.loadImage(imageViews?.get(i), imageUrls[i])
                            }
                        }
                        imageViews
                    }
                }

                AdBean.CRE_TYPE_VIDEO -> {
                    //视频广告类型
                    imageView = (inflate?.findViewById<JzvdStd>(R.id.iv_video))
                    imageView?.layoutParams = relayout?.layoutParams?.width?.div(2)
                        ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                    imageView?.visibility = VISIBLE
                    imageView?.mWidth = Utils.getScreenSize(true)[0].div(2)
                    imageView?.mHeight = Utils.getScreenSize(true)[1].div(7)
                    imageView?.setUp(response?.adInfo?.reward_video?.videoUrl, "")
                    imageView?.setAdBean(response?.adInfo)
                    imageView?.startVideo()

                }

            }


            // 设置iv_shake相对于imageview居中显示
            iv_shake?.visibility = VISIBLE
            val params: LayoutParams? = imageView?.layoutParams?.height?.div(2)?.let {
                imageView.layoutParams?.width?.div(2)?.let { it1 -> LayoutParams(it1, it) }
            }
            params?.leftMargin = Utils.getScreenSize(true)[0].div(8)
            params?.addRule(CENTER_VERTICAL)
            iv_shake?.layoutParams = params

            //title描述
            val tv_item_params =
                LayoutParams(Utils.getScreenSize(true)[0].div(2), LayoutParams.WRAP_CONTENT)
            imageView?.id?.let { tv_item_params.addRule(RIGHT_OF, it) }
            tv_item_linear?.layoutParams = tv_item_params

            //logo
            val logo_params = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
            imageView?.let { logo_params.addRule(RIGHT_OF, it.id) }
            logo_params.addRule(ALIGN_PARENT_BOTTOM)
            logo_item_linear?.layoutParams = logo_params

            //close关闭
            val close_params =
                LayoutParams(50, 50)
            close_params.addRule(ALIGN_PARENT_BOTTOM)
            close_params.addRule(ALIGN_PARENT_END)
            iv_close?.layoutParams = close_params


            title?.text = response?.title
            subTitle?.text = response?.subTitle
            //广告区域点击
            inflate?.setOnClickListener {
                response?.handleClick(inflate, true)//触发点击并上报点击事件
                LogUtils.d("HaloSDKDemo:AdType:" + response?.type + "::AdClick")
            }

            iv_close?.setOnClickListener {
                inflate?.visibility = GONE
                response?.handleClose()//上报关闭事件
                mUnifiedNativeAdView?.removeAllViews()//清空view
                LogUtils.d("HaloSDKDemo:AdType:" + response?.type + "::AdClosed")
                if (sensorManager != null) {
                    sensorManager?.unregisterListener(sensorEventListener) //广告关闭时摇一摇监听关闭
                }
            }

            val relativeLayout = inflate?.findViewById<RelativeLayout>(R.id.relativelayout)
            val viewTreeObserver = relativeLayout?.viewTreeObserver
            viewTreeObserver?.addOnGlobalLayoutListener {
                val viewCovered = Utils.isViewCovered(relativeLayout, 0.3f)
                if (!viewCovered && !isShow) {
                    isShow = true
                    response?.handleShow()//上报展示事件
                    LogUtils.d("HaloSDKDemo:AdType:" + response?.type + "::AdShowSuccess")
                }
            }

            viewTreeObserver?.addOnScrollChangedListener {
                val viewCovered = Utils.isViewCovered(relativeLayout, 0.3f)
                if (!viewCovered && !isShow) {
                    isShow = true
                    response?.handleShow()//上报展示事件
                    LogUtils.d("HaloSDKDemo:AdType:" + response?.type + "::AdShowSuccess")
                }
            }
        }
    }

    @SuppressLint("UseCompatLoadingForDrawables")
    private fun changeImage() {
        if (iv_shake?.drawable?.current?.constantState === resources.getDrawable(R.drawable.hj_shake_one).current.constantState) {
            iv_shake?.setImageResource(R.drawable.hj_shake_two) // 切换到第二个图片资源
        } else {
            iv_shake?.setImageResource(R.drawable.hj_shake_one) // 切换回第一个图片资源
        }
    }

    private val sensorEventListener: SensorEventListener = object : SensorEventListener {
        override fun onSensorChanged(event: SensorEvent) {
            val curTime = System.currentTimeMillis()
            if ((curTime - lastUpdate) > TIME_THRESHOLD) {
                val diffTime = (curTime - lastUpdate)
                lastUpdate = curTime

                val x = event.values[0]
                val y = event.values[1]
                val z = event.values[2]

                val speed =
                    (abs((x + y + z - lastX - lastY - lastZ).toDouble()) / diffTime * 10000).toFloat()
                if (speed >= 0) { // 摇动的判定条件
                    // 切换图片逻辑
                    changeImage()
                }
                if (speed > FORCE_THRESHOLD && !isFinishing && getWindow()?.getDecorView()
                        ?.getWindowVisibility() == View.VISIBLE
                ) {
                    //举例:摇一摇触发点击
                    response?.handleClick(inflate, true)
                    LogUtils.d("HaloSDKDemo:AdType:" + response?.type + "::AdClick")
                }

                lastX = x
                lastY = y
                lastZ = z
            }
        }

        override fun onAccuracyChanged(sensor: Sensor, accuracy: Int) {
            // 可以选择忽略这个方法，因为我们不关心传感器精度变化。
        }
    }


    private val hlUnifiedNativeListener: HlUnifiedNativeListener =
        object : HlUnifiedNativeListener {
            override fun onAdLoadSuccess(response: List<NativeResponse?>?) {
                uniFiedNativeView = UnifiedNativeView(this@NativeUnifiedActivity)
                uniFiedNativeView?.showView(response)
                mUnifiedNativeAdView?.removeAllViews()
                mUnifiedNativeAdView?.addView(uniFiedNativeView)
                LogUtils.d("HaloSDKDemo:NativeUnified::onAdLoadSuccess:" + "ecpm:" + hlUnifiedNativeAd?.ecpm);
            }

            override fun onAdFailed(msg: String?, code: Int) {
                LogUtils.d("HaloSDKDemo:NativeUnified::onAdFailedMsg:" + msg + "onAdFailedCode:" + code);
            }

        }

    companion object {
        private const val FORCE_THRESHOLD = 170

        private const val TIME_THRESHOLD = 100
    }


    override fun onDestroy() {
        super.onDestroy()
        if (hlUnifiedNativeAd != null) {
            hlUnifiedNativeAd?.release()
            hlUnifiedNativeAd = null
        }
        if (mUnifiedNativeAdView != null) {
            mUnifiedNativeAdView?.removeAllViews()
            mUnifiedNativeAdView = null
        }
    }
}
