package com.hling.demo.AdsView

import android.app.Activity
import android.os.Bundle
import android.view.View
import android.view.WindowManager
import android.widget.Toast
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlFullRewardVideoAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlFullRewardVideoListener
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R

class RewardFullVideoActivity : BaseAdActivity() {
    private var hlFullRewardVideoAd: HlFullRewardVideoAd? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_fullreward)
        window.addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)

        findViewById<View>(R.id.btn_request).setOnClickListener { v: View? ->
            if (!ActivityUtil.isFastClick) {
                loadRewardVideo()
            }
        }

        findViewById<View>(R.id.btn_load).setOnClickListener { v: View? ->
            if (!ActivityUtil.isFastClick) {
                loadRewardVideo()
            }
        }
    }

    private fun loadRewardVideo() {
        hlFullRewardVideoAd =
            HlFullRewardVideoAd(this, AppConfig.ReWARD_VIDEO_FULL_ID, hlFullRewardVideoListener,false)//isCloseVideoDialog可不填 默认false 为true时关闭激励视频弹框
        hlFullRewardVideoAd?.loadAd()
    }

    private val hlFullRewardVideoListener: HlFullRewardVideoListener =
        object : HlFullRewardVideoListener {
            override fun onAdLoadSuccess() {
                if (hlFullRewardVideoAd != null) {
                    LogUtils.d("HaloSDKDemo:RewardFullVideo::onAdLoadSuccess:"+"ecpm:"+hlFullRewardVideoAd?.ecpm);
                    hlFullRewardVideoAd?.showAd()
                }
            }

            override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d("HaloSDKDemo:RewardFull::onAdFailedMsg:" + msg + "onAdFailedCode:" + code);
            }

            override fun onAdShow() {
            LogUtils.d("HaloSDKDemo:RewardFull::onAdShow");
            }

            override fun onAdClose() {
            LogUtils.d("HaloSDKDemo:RewardFull::onAdClose");
            }

            override fun onAdClick() {
            LogUtils.d("HaloSDKDemo:RewardFull::onAdClick");
            }

            override fun onPlayEnd() {
            LogUtils.d("HaloSDKDemo:RewardFull::onPlayEnd");
            }


            override fun onRewardComplete() {
            LogUtils.d("HaloSDKDemo:RewardFull::onRewardComplete");
                Toast.makeText(this@RewardFullVideoActivity, "领取奖励", Toast.LENGTH_LONG).show()
            }

            override fun onProgress(videoProgress: Int) {
                LogUtils.d("HaloSDKDemo:RewardFull::onProgress:$videoProgress");
            }
        }

    override fun onDestroy() {
        super.onDestroy()
        if (hlFullRewardVideoAd != null) {
            hlFullRewardVideoAd?.release()
            hlFullRewardVideoAd = null
        }
    }
}
