package com.hling.demo.AdsView

import android.os.Bundle
import android.view.View
import android.view.WindowManager
import android.widget.Toast
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.bussiness.module_sdk.base.BaseAdActivity
import com.halomobi.ssp.bussiness.module_sdk.manager.HlRewardVideoAd
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlRewardVideoListener
import com.hling.demo.Config.AppConfig
import com.hling.demo.Utils.ActivityUtil
import com.zjkj.gtm.R

class RewardVideoActivity : BaseAdActivity() {
    private var hlRewardVideoAd: HlRewardVideoAd? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_reward)
        window.addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)

        findViewById<View>(R.id.btn_request).setOnClickListener { v: View? ->
            if (!ActivityUtil.isFastClick) {
                loadRewardVideo()
            }
        }

        findViewById<View>(R.id.btn_load).setOnClickListener { v: View? ->
            if (!ActivityUtil.isFastClick) {
                loadRewardVideo()
            }
        }
    }

    private fun loadRewardVideo() {
        hlRewardVideoAd = HlRewardVideoAd(this, AppConfig.REWARD_VIDEO_ID, hlRewardVideoListener,false)//isCloseVideoDialog可不填 默认false 为true时关闭激励视频弹框
        hlRewardVideoAd?.loadAd()
    }

    private val hlRewardVideoListener: HlRewardVideoListener = object : HlRewardVideoListener {
        override fun onAdLoadSuccess() {

            if (hlRewardVideoAd != null) {
                LogUtils.d("HaloSDKDemo:RewardVideo::onAdLoadSuccess:"+"ecpm:"+hlRewardVideoAd?.ecpm);
                hlRewardVideoAd?.showAd()
            }
        }

        override fun onAdFailed(msg: String?, code: Int) {
            LogUtils.d("HaloSDKDemo:Reward::onAdFailedMsg:" + msg + "onAdFailedCode:" + code);
        }

        override fun onAdShow() {
            LogUtils.d("HaloSDKDemo:Reward::onAdShow");
        }

        override fun onAdClose() {
            LogUtils.d("HaloSDKDemo:Reward::onAdClose");
        }

        override fun onAdClick() {
            LogUtils.d("HaloSDKDemo:Reward::onAdClick");
        }

        override fun onPlayEnd() {
            LogUtils.d("HaloSDKDemo:Reward::onPlayEnd");
        }


        override fun onRewardComplete() {
            LogUtils.d("HaloSDKDemo:Reward::onRewardComplete");
            Toast.makeText(this@RewardVideoActivity, "领取奖励", Toast.LENGTH_LONG).show()
        }

        override fun onProgress(videoProgress: Int) {
            LogUtils.d("HaloSDKDemo:Reward::videoProgress:$videoProgress");
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        if (hlRewardVideoAd != null) {
            hlRewardVideoAd?.release()
            hlRewardVideoAd = null
        }
    }
}
