package com.hling.demo.Utils

import android.app.Activity
import java.util.Stack

object ActivityUtil {
    private var lastClickTime: Long = 0
    private var activityStack: Stack<Activity?>? = null

    val isFastClick: Boolean
        get() {
            val time = System.currentTimeMillis()
            if (time - lastClickTime < 1000) {
                return true
            }
            lastClickTime = time
            return false
        }

    fun removeAllActivity() {
        var i = 0
        val size = activityStack?.size
        while (i < (size ?: 0)) {
            if (null != activityStack?.get(i)) {
                activityStack?.get(i)?.finish()
            }
            i++
        }
        activityStack?.clear()
    }

    fun addActivity(activity: Activity?) {
        if (activityStack == null) {
            activityStack = Stack()
        }
        activityStack?.add(activity)
    }
}
