package com.halomobi.ssp.base.common

interface ConstantPool  {


   enum class AdType(val adName: String, val type: Int) {
        BANNER("横幅广告", 1),
        SPLASH("开屏广告", 2),
        INSERT("插屏广告", 3),
        INSERTFULLSCREEN("插全屏广告", 3),
        NATIVE("原生广告", 4),
        UNIFIEDNATIVE("自渲染原生广告", 4),
        REWARDVIDEO("激励视频广告", 5),
        REWARDFULLVIDEO("全屏激励视频广告", 5);
//        FLOATAD("浮窗广告", 6);

        companion object {
            fun getAdTypeByType(type: Int): AdType? {
                val values = values()
                for (a in values) {
                    if (a.type == type) {
                        return a
                    }
                }
                return null
            }
        }
    }

    interface EroType {
        companion object {
            const val EXCEPTION: Int = 1001
            const val LOAD_AD_TIMEOUT: Int = 1002
            const val RENDER_AD_TIMEOUT: Int = 1003
            const val RENDER_FAILED: Int = 1004
            const val AD_SHOW_FAILED: Int = 1005
            const val BACK_EMPTY: Int = 1006
            const val DOWNLOAD_FAILED: Int = 1007
            const val OPEN_APP_FAILED: Int = 1008
            const val INSTALL_FAILED: Int = 1009
            const val BAD_TRACK: Int = 1010
            const val WITHOUT_NET: Int = 1011
            const val PARAMS_ERO: Int = 1012
            const val ERROR_FILE_NOT_FOUND: Int = 1013
            const val ERROR_UNKNOWN_HOST: Int = 1014
            const val INIT_FAILED: Int = 1015
            const val SHOWINGERROR: Int = 1016 //视频播放过程中不允许加载下一条.
            const val PLAYINGERROR: Int = 1017 //视频播放过程中报错.
        }
    }



    interface TrackerType {
        companion object {
            const val DISPLAY: Int = 0
            const val CLICK: Int = 1
            const val CLOSE: Int = 2
            const val DEEP_LINK: Int = 3
            const val S_DOWNLOAD: Int = 4
            const val DOWNLOADED: Int = 5
            const val INSTALLED: Int = 6
            const val INSTALL_START: Int = 7
            const val OPEN: Int = 8
            const val DEEP_LINK_OPEN: Int = 9
            const val MUTE_TRACKER: Int = 10
            const val UNMUTE_TRACKER: Int = 11
            const val VIDEO_START_TRACKER: Int = 12
            const val VIDEO_CLICK_TRACKER: Int = 13
            const val VIDEO_PAUSE_TRACKER: Int = 14
            const val VIDEO_COMPLETE_TRACKER: Int = 15
            const val VIDEO_SKIP_TRACKER: Int = 16
            const val VIDEO_PLAYING_0_TRACKER: Int = 17
            const val VIDEO_PLAYING_1_TRACKER: Int = 18
            const val VIDEO_PLAYING_2_TRACKER: Int = 19
            const val VIDEO_PLAYING_3_TRACKER: Int = 20
            const val VIDEO_PLAYING_4_TRACKER: Int = 21
            const val VIDEO_LOADED_TRACKER: Int = 22
        }
    }

    companion object {
        //下载二次确认
        const val SWICH_DWLCONFIRM: String = "dwlconfirm"

        const val AD_TYPE: String = "adType"

        const val SSP_SDK: String = "SSP_SDK"

        const val A_SDK: String = "ASDK"

        const val UA_KEY: String = "UA_KEY_web"

        const val IMEI: String = "imei"

        const val DEFAULT_IMEI: String = "000000000000000"

        const val DEFAULT_CELLULAR_ID: String = "0"

        const val DEFAULT_LAC: String = "0"

    }
}
