package com.halomobi.ssp.bussiness.module_Exception.manager

import android.content.Context
import com.halomobi.ssp.base.utils.ToolsUtils.getPluginVersion
import com.halomobi.ssp.bussiness.module_Exception.sentry.Sentry
import com.halomobi.ssp.bussiness.module_Exception.sentry.android.core.SentryAndroid
import java.io.File

object SentryManger {
    @JvmField
    var RELEASE: String = ""
    @JvmField
    var DSN: String? = null
    @JvmField
    var canLoadSoFile: Boolean = false
    private var mInit = false

    fun setSentryDsn(dsn: String?, release: String) {
        DSN = dsn
        RELEASE = release
    }

    fun setSentryTag(map: Map<String, String?>?) {
        if (map != null) {
            for (key in map.keys) {
                Sentry.setTag(key, map[key].toString())
            }
        }
    }

    fun initSentry(context: Context) {
        if (mInit) {
            return
        }
        val file = File(context.applicationInfo.nativeLibraryDir)
        if (file.exists() && file.isDirectory) {
            val files = file.listFiles()
            if (files != null) {
                for (subFile in files) {
                    if (subFile.name.contains("libsentry")) {
                        canLoadSoFile = true
                        break
                    }
                }
            }
        }
        SentryAndroid.init(
            context
        ) { options -> options.release = getPluginVersion(context) }
        mInit = true
    }

    fun destroy() {
        mInit = false
        DSN = null
    }
}
