package com.halomobi.ssp.bussiness.module_Exception.sentry;

import org.jetbrains.annotations.NotNull;

import com.halomobi.ssp.bussiness.module_Exception.sentry.transport.AsyncHttpTransport;
import com.halomobi.ssp.bussiness.module_Exception.sentry.transport.ITransport;
import com.halomobi.ssp.bussiness.module_Exception.sentry.transport.RateLimiter;
import com.halomobi.ssp.bussiness.module_Exception.sentry.util.Objects;

/** Creates {@link AsyncHttpTransport}. */

public final class AsyncHttpTransportFactory implements ITransportFactory {

  @Override
  public @NotNull ITransport create(
      final @NotNull SentryOptions options, final @NotNull RequestDetails requestDetails) {
    Objects.requireNonNull(options, "options is required");
    Objects.requireNonNull(requestDetails, "requestDetails is required");

    return new AsyncHttpTransport(
        options, new RateLimiter(options.getLogger()), options.getTransportGate(), requestDetails);
  }
}
