package com.halomobi.ssp.bussiness.module_Exception.sentry;

import org.jetbrains.annotations.NotNull;

import com.halomobi.ssp.bussiness.module_Exception.sentry.transport.ITransport;
import com.halomobi.ssp.bussiness.module_Exception.sentry.transport.NoOpTransport;


public final class NoOpTransportFactory implements ITransportFactory {

  private static final NoOpTransportFactory instance = new NoOpTransportFactory();

  public static NoOpTransportFactory getInstance() {
    return instance;
  }

  private NoOpTransportFactory() {}

  @Override
  public @NotNull ITransport create(
      final @NotNull SentryOptions options, final @NotNull RequestDetails requestDetails) {
    return NoOpTransport.getInstance();
  }
}
