package com.halomobi.ssp.bussiness.module_report.db;


import static com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager.COLUMN_TRACK_TIME;
import static com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager.COLUMN_TRACK_URL;
import static com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager.TABLE;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;

import com.halomobi.ssp.model.request.config.SDKInfo;


public class AdSQLHelper extends SQLiteOpenHelper {

    private static final String DATABASE_NAME = SDKInfo.ADTAG + ".db";
    private static final int DATABASE_VERSION = SDKInfo.DB_VER;
    private static final String CREATE_TRACKERS_TABLE = "CREATE TABLE IF NOT EXISTS "
            + TABLE
            + "( "
            + BaseColumns._ID
            + " INTEGER PRIMARY KEY AUTOINCREMENT, "
            + COLUMN_TRACK_URL
            + " TEXT NOT NULL , "
            + COLUMN_TRACK_TIME
            + " TEXT NOT NULL );";

    AdSQLHelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_TRACKERS_TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + TABLE);
        db.execSQL(CREATE_TRACKERS_TABLE);
    }

}
