package com.halomobi.ssp.bussiness.module_report.track

import android.text.TextUtils
import com.halomobi.ssp.framework.schedule.ITask.LaunchMode
import com.halomobi.ssp.model.net.absnet.AbsNetTask
import com.halomobi.ssp.model.request.bean.DnsBean
import java.net.HttpURLConnection

/**
 * 上报监播
 */
internal class ReportTrackerTask(private val mTracks: Set<String?>?) : AbsNetTask(ReqType.Get) {
    /**
     * @return 是否是最后一条监播
     */
    var isLastRequest: Boolean = false
        private set

    init {
        //设置可以通过IP对应关系重试发送监播
        setReTry(true)
    }

    override val entity: ByteArray
        get() = ByteArray(0)

    public override val url: String?
        get() = mDnsBean?.url

    override fun onAddHeaders(urlConnection: HttpURLConnection?) {
        if (TextUtils.isEmpty(mDnsBean?.host)) {
            return
        }
        urlConnection?.setRequestProperty("Host", mDnsBean?.host)
    }

    override val launchMode: LaunchMode
        get() = LaunchMode.ADD_NEW

    override val name: String?
        get() = javaClass.simpleName




    override fun run() {
        var i = 0
        if (mTracks != null) {
            for (track in mTracks) {
                mDnsBean = DnsBean()

                mDnsBean?.url = track?.trim { it <= ' ' }.toString()

                if (++i == mTracks.size) {
                    //最后一条监播
                    isLastRequest = true
                }

                super.run()
            }
        }
    }
}
