package com.halomobi.ssp.bussiness.module_sdk.base

import android.app.Activity
import android.content.Intent
import android.content.pm.ActivityInfo
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.widget.Toast
import androidx.annotation.RequiresApi
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.Jzvd
import com.halomobi.ssp.framework.controller.AdController
import com.halomobi.ssp.model.request.config.SDKInfo

open class BaseAdActivity : Activity() {

    //判断当前activity是否在前台
    private var isBackground = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
//        requestedOrientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE
    }

    override fun onResume() {
        super.onResume()
        isBackground = false
        Jzvd.goOnPlayOnResume()
    }

    override fun onPause() {
        super.onPause()
        isBackground = true
        Jzvd.goOnPlayOnPause()
    }

    /**
     * 接收通过deepLink跳转其他app activity返回结果
     */

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_CANCELED) {
            //添加100ms延时策略，解决没有系统启动弹窗场景下因系统生命周期调度问题导致打开app的同时打开H5页面
            Handler(Looper.getMainLooper()).postDelayed(Runnable() {
                run {
                    if (!isBackground) {
                        AdController.getInstance(this)?.openWebPage()
                    }
                }

            }, 100);
        } else {
            // 处理活动成功完成的情况
        }
    }

    override fun onBackPressed() {
        super.onBackPressed()
        Jzvd.releaseAllVideos()
    }

    override fun onDestroy() {
        super.onDestroy()
        Jzvd.releaseAllVideos()
    }
}


