package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.AdListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiBannerListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlBannerListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmBannerAd
import com.halomobi.ssp.framework.Abstract.AbstractAd

class HlBannerAd(context: Activity?, hlAdID: String?, listener: HlBannerListener?) :
    HlApiBannerListener, AdListener {
    private var mContext: Activity? = null
    private var mHlBannerListener: HlBannerListener? = null
    private var mHlAdId: String? = null

    private var hmBannerAd: HmBannerAd? = null

    private var currentPrice = 0

    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )
        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters",
                ConstantPool.EroType.PARAMS_ERO
            )
        } else {
            mContext = context
            mHlBannerListener = listener
            mHlAdId = hlAdID
            ConfigPool.AdShowTypeName = ConstantPool.AdType.BANNER.adName
            hmBannerAd = HmBannerAd(mContext, mHlAdId)
            hmBannerAd?.setHjAdListener(this)
        }
    }


    override fun loadAd() {
        hmBannerAd?.loadAd()
    }

    override fun release() {
        hmBannerAd?.release()
    }

    override fun onDisplayAd() {
        mHlBannerListener?.onDisplayAd()
    }

    override fun onClickAd(click_type: Int) {
        mHlBannerListener?.onClickAd()
    }

    override fun onCloseAd() {
        mHlBannerListener?.onCloseAd()
    }

    override fun onAdReady() {
        if (hmBannerAd != null) {
            hmBannerAd?.getAdView<AbstractAd.AbstractAdView>()?.showAdView()
            mHlBannerListener?.onAdLoadSuccess(hmBannerAd?.getAdView())
        }
    }

    override fun onAdError(msg: String?, code: Int) {
        mHlBannerListener?.onAdFailed(msg, code)
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (hmBannerAd != null) {
                if ((hmBannerAd?.ecpm?:0) >= currentPrice) {
                    currentPrice = hmBannerAd?.ecpm?:0
                }
            }
            return currentPrice
        }

    //设置自刷新时间
    fun setRefresh(refreshCount: Int) {
        hmBannerAd?.setRefresh(refreshCount)
    }

    //设置停止自刷新
    fun stopRefresh() {
        hmBannerAd?.stopRefresh()
    }
}
