package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.AdListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiFullInterListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlFullinterListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmInsertFullScreenAd

class HlFullInterAd(context: Activity?, hlAdID: String?, listener: HlFullinterListener?) :
    HlApiFullInterListener, AdListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null

    private var hlFullinterListener: HlFullinterListener? = null

    private var insertAd: HmInsertFullScreenAd? = null
    private var currentPrice = 0


    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )

        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )

        } else {
            mContext = context
            mHlAdId = hlAdID
            hlFullinterListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.INSERTFULLSCREEN.adName
            insertAd = HmInsertFullScreenAd(mContext, mHlAdId)
            insertAd?.setHjAdListener(this)
        }
    }

    override fun onClickAd(click_type: Int) {
        hlFullinterListener?.onClickAd()
    }

    override fun onCloseAd() {
        hlFullinterListener?.onCloseAd()
    }

    override fun onAdReady() {
        hlFullinterListener?.onAdLoadSuccess()
    }

    override fun onDisplayAd() {
        hlFullinterListener?.onDisplayAd()
    }


    override fun onAdError(msg: String?, code: Int) {
        hlFullinterListener?.onAdFailed(msg, code)
    }

    override fun loadAd() {
        insertAd?.loadAd()
    }

    override fun release() {
        insertAd?.clearAd()
    }

    override fun showAd() {
        insertAd?.showAd()
    }


    val ecpm: Int
        //获取广告ecpm
        get(){
            if (insertAd != null) {
                if ((insertAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = insertAd?.ecpm?:0
                }
            }
            return currentPrice
        }
}
