package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.common.GlobalVariablePool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.RewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiFullRewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlFullRewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlRewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmFullRewardVideoAd
import com.halomobi.ssp.bussiness.module_sdk.normal.HmRewardVideoAd

class HlFullRewardVideoAd(
    context: Activity?,
    hlAdID: String?,
    listener: HlFullRewardVideoListener?
) :
    HlApiFullRewardVideoListener, RewardVideoListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null
    private var currentPrice = 0
    private var hlFullRewardVideoListener: HlFullRewardVideoListener? = null
    private var mHmFullRewardVideoAd: HmFullRewardVideoAd? = null

    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )

        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )

        } else {
            mContext = context
            mHlAdId = hlAdID
            hlFullRewardVideoListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.REWARDFULLVIDEO.adName
            mHmFullRewardVideoAd = HmFullRewardVideoAd(mContext, mHlAdId, this)
        }
    }


    //重写类的构造方法 设置激励视频弹框是否关闭
    constructor(context: Activity?, hlAdID: String?, listener: HlFullRewardVideoListener?, isCloseVideoDialog:Boolean):this(context, hlAdID, listener){
        GlobalVariablePool.isCloseFullVideDialog=isCloseVideoDialog
    }


    override fun onSuccess() {
        hlFullRewardVideoListener?.onAdLoadSuccess()
    }

    override fun onError(errorCode: Int, errorMsg: String?) {
        hlFullRewardVideoListener?.onAdFailed(errorMsg, errorCode)
    }

    override fun onAdShow() {
        hlFullRewardVideoListener?.onAdShow()
    }

    override fun onAdClose() {
        hlFullRewardVideoListener?.onAdClose()
    }

    override fun onAdClick() {
        hlFullRewardVideoListener?.onAdClick()
    }

    override fun onPlayEnd() {
        hlFullRewardVideoListener?.onPlayEnd()
    }

    override fun onRewardComplete() {
        hlFullRewardVideoListener?.onRewardComplete()
    }

    override fun onProgress(videoProgress: Int) {
        hlFullRewardVideoListener?.onProgress(videoProgress)
    }

    override fun onCacheSuccess() {
//        hlFullRewardVideoListener?.onCacheSuccess()
    }

    override fun onCacheFailed() {
//        hlFullRewardVideoListener?.onCacheFailed()
    }

    override fun loadAd() {
        if (mHmFullRewardVideoAd != null) {
            mHmFullRewardVideoAd?.loadAd()
        }
    }

    override fun showAd() {
        if (mHmFullRewardVideoAd?.isReady == true) {
            mHmFullRewardVideoAd?.show()
        }
    }

    override fun release() {
        if (mHmFullRewardVideoAd != null) {
            mHmFullRewardVideoAd = null
        }
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (mHmFullRewardVideoAd != null) {
                if ((mHmFullRewardVideoAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = mHmFullRewardVideoAd?.ecpm?:0
                }
            }
            return currentPrice
        }
}
