package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import android.view.View
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeAdListener
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeResponse
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiNativeListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlNativeListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmNativeAd

class HlNativeAd(
    context: Activity?,
    hlAdID: String?,
    directionType: Int,
    listener: HlNativeListener?
) :
    HlApiNativeListener, NativeAdListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null
    private var hlNativeListener: HlNativeListener? = null
    private var hmNativeAd: HmNativeAd? = null

    private var mView: View? = null
    private var currentPrice = 0


    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )
        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )

        } else {
            mContext = context
            mHlAdId = hlAdID
            hlNativeListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.NATIVE.adName
            hmNativeAd = HmNativeAd(mContext, mHlAdId, directionType) //1.左图右文 2.左文右图 3.上图下文  4.纯图
        }

    }


    override fun onAdReach(response: List<NativeResponse?>?, view: View?) {
        mView = view
        hlNativeListener?.onAdLoadSuccess(view)
    }

    override fun onAdReach(response: List<NativeResponse?>?) {
    }



    override fun onAdError(msg: String?, code: Int) {
        hlNativeListener?.onAdFailed(msg, code)
    }

    override fun onAdShow() {
        hlNativeListener?.onAdShow(mView)
    }

    override fun onAdClick() {
        hlNativeListener?.onAdClick(mView)
    }

    override fun onAdClose() {
        hlNativeListener?.onAdClose(mView)
    }

    override fun loadAd() {
        if (hmNativeAd != null) {
            hmNativeAd?.requestAd(this)
        }
    }

    override fun release() {
        if (hmNativeAd != null) {
            hmNativeAd = null
        }
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (hmNativeAd != null) {
                if ((hmNativeAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = hmNativeAd?.ecpm?:0
                }
            }
            return currentPrice
        }
}
