package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.common.GlobalVariablePool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.RewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiRewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlRewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmRewardVideoAd

class HlRewardVideoAd(context: Activity?, hlAdID: String?, listener: HlRewardVideoListener?):
    HlApiRewardVideoListener, RewardVideoListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null

    private var hlRewardVideoListener: HlRewardVideoListener? = null

    private var mHmRewardVideoAd: HmRewardVideoAd? = null

    private var currentPrice = 0


    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )

        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )

        } else {
            mContext = context
            mHlAdId = hlAdID
            hlRewardVideoListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.REWARDVIDEO.adName
            mHmRewardVideoAd = HmRewardVideoAd(mContext, mHlAdId, this)
        }
    }
     //重写类的构造方法 设置激励视频弹框是否关闭
    constructor(context: Activity?, hlAdID: String?, listener: HlRewardVideoListener?,isCloseVideoDialog:Boolean):this(context, hlAdID, listener){
        GlobalVariablePool.isCloseVideDialog=isCloseVideoDialog
    }


    override fun onSuccess() {
        hlRewardVideoListener?.onAdLoadSuccess()
    }

    override fun onError(errorCode: Int, errorMsg: String?) {
        hlRewardVideoListener?.onAdFailed(errorMsg, errorCode)
    }

    override fun onAdShow() {
        hlRewardVideoListener?.onAdShow()
    }

    override fun onAdClose() {
        hlRewardVideoListener?.onAdClose()
    }

    override fun onAdClick() {
        hlRewardVideoListener?.onAdClick()
    }

    override fun onPlayEnd() {
        hlRewardVideoListener?.onPlayEnd()
    }

    override fun onRewardComplete() {
        hlRewardVideoListener?.onRewardComplete()
    }

    override fun onProgress(videoProgress: Int) {
        hlRewardVideoListener?.onProgress(videoProgress)
    }

    override fun onCacheSuccess() {
//        hlRewardVideoListener?.onCacheSuccess()
    }

    override fun onCacheFailed() {
//        hlRewardVideoListener?.onCacheFailed()
    }

    override fun loadAd() {
        if (mHmRewardVideoAd != null) {
            mHmRewardVideoAd?.loadAd()
        }
    }

    override fun showAd() {
        if (mHmRewardVideoAd?.isReady == true) {
            mHmRewardVideoAd?.show()
        }
    }

    override fun release() {
        if (mHmRewardVideoAd != null) {
            mHmRewardVideoAd = null
        }
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (mHmRewardVideoAd != null) {
                if ((mHmRewardVideoAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = mHmRewardVideoAd?.ecpm?:0
                }
            }
            return currentPrice
        }
}
