package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import android.view.ViewGroup
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.AdListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiSplashListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlSplashListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmSplashAd
import com.halomobi.ssp.framework.Abstract.AbstractAd
class HlSplashAd(
    context: Activity?,
    hlAdID: String?,
    adContainer: ViewGroup?,
    listener: HlSplashListener?
) :
    HlApiSplashListener, AdListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null

    private var currentPrice = 0

    private var hlSplashListener: HlSplashListener? = null

    private var hmSplashAd: HmSplashAd? = null

    private var mAdContainer: ViewGroup? = null

    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )

        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )
        } else {
            mContext = context
            mHlAdId = hlAdID
            mAdContainer = adContainer
            hlSplashListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.SPLASH.adName
            hmSplashAd = HmSplashAd(mContext, null, mHlAdId)
            hmSplashAd?.setHjAdListener(this)
            hmSplashAd?.setIsJumpTargetWhenFail(true)
            hmSplashAd?.showCountDown(true) // 设置是否显示倒计时效果
            hmSplashAd?.setShowAdTime((5 * 1000).toLong()) // 自定义展示时间
        }
    }

    override fun onDisplayAd() {
        hlSplashListener?.onDisplayAd()
    }

    override fun onClickAd(click_type: Int) {
        hlSplashListener?.onClickAd()
    }

    override fun onCloseAd() {
        hlSplashListener?.onCloseAd()
    }

    override fun onAdReady() {
        hlSplashListener?.onAdLoadSuccess()
    }

    override fun onAdError(msg: String?, code: Int) {
        hlSplashListener?.onAdFailed(msg, code)
    }

    override fun loadAd() {
        if (hmSplashAd != null) {
            hmSplashAd?.loadAd()
        }
    }

    override fun showAd() {
        if (hmSplashAd != null) {
            hmSplashAd?.getAdView<AbstractAd.AbstractAdView>()?.showAdView()
            mAdContainer?.addView(hmSplashAd?.getAdView())
        }
    }

    override fun release() {
        if (hmSplashAd != null) {
            hmSplashAd = null
        }
        mAdContainer?.removeAllViews()
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (hmSplashAd != null) {
                if ((hmSplashAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = hmSplashAd?.ecpm ?: 0
                }
            }
            return currentPrice
        }
}
