package com.halomobi.ssp.bussiness.module_sdk.manager

import android.app.Activity
import android.text.TextUtils
import android.view.View
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeAdListener
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeResponse
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlApiUnifiedNativeListener
import com.halomobi.ssp.bussiness.module_sdk.managerlistener.HlUnifiedNativeListener
import com.halomobi.ssp.bussiness.module_sdk.normal.HmUnifiedNativeAd

class HlUnifiedNativeAd(context: Activity?, hlAdID: String?, listener: HlUnifiedNativeListener?) :
    HlApiUnifiedNativeListener, NativeAdListener {
    private var mContext: Activity? = null

    private var mHlAdId: String? = null

    private var currentPrice = 0

    private var hlUnifiedNativeListener: HlUnifiedNativeListener? = null

    private var hmUnifiedNativeAd: HmUnifiedNativeAd? = null

    init {
        if (Utils.context == null) {
            listener?.onAdFailed(
                "Not initialized successfully",
                ConstantPool.EroType.INIT_FAILED
            )

        } else if (context == null || TextUtils.isEmpty(hlAdID)) {
            listener?.onAdFailed(
                "Cannot have empty parameters！",
                ConstantPool.EroType.PARAMS_ERO
            )
        } else {
            mContext = context
            mHlAdId = hlAdID
            hlUnifiedNativeListener = listener
            ConfigPool.AdShowTypeName = ConstantPool.AdType.UNIFIEDNATIVE.adName
            hmUnifiedNativeAd = HmUnifiedNativeAd(mContext, mHlAdId)
        }

    }

    override fun onAdReach(response: List<NativeResponse?>?, view: View?) {

    }

    override fun onAdReach(response: List<NativeResponse?>?) {
        hlUnifiedNativeListener?.onAdLoadSuccess(response)
    }

    override fun onAdError(msg: String?, code: Int) {
        hlUnifiedNativeListener?.onAdFailed(msg, code)
    }

    override fun onAdShow() {

    }

    override fun onAdClick() {
    }

    override fun onAdClose() {
    }

    override fun loadAd() {
        if (hmUnifiedNativeAd != null) {
            hmUnifiedNativeAd?.requestAd(this)
        }
    }

    override fun release() {
        if (hmUnifiedNativeAd != null) {
            hmUnifiedNativeAd = null
        }
    }

    val ecpm: Int
        //获取广告ecpm
        get() {
            if (hmUnifiedNativeAd != null) {
                if ((hmUnifiedNativeAd?.ecpm ?: 0) >= currentPrice) {
                    currentPrice = hmUnifiedNativeAd?.ecpm ?: 0
                }
            }
            return currentPrice
        }
}
