package com.halomobi.ssp.bussiness.module_sdk.normal

import android.annotation.SuppressLint
import android.app.Activity
import android.app.AlertDialog
import android.content.Context
import android.graphics.Color
import android.os.Build
import android.os.CountDownTimer
import android.text.TextUtils
import android.view.Gravity
import android.view.LayoutInflater
import android.view.MotionEvent
import android.view.View
import android.widget.ImageView
import android.widget.ProgressBar
import android.widget.RelativeLayout
import android.widget.RelativeLayout.ALIGN_PARENT_BOTTOM
import android.widget.RelativeLayout.ALIGN_PARENT_RIGHT
import android.widget.TextView
import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.common.GlobalVariablePool
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager
import com.halomobi.ssp.bussiness.module_sdk.listener.RewardVideoListener
import com.halomobi.ssp.bussiness.module_sdk.view.imageloader.ImageLoader
import com.halomobi.ssp.bussiness.module_video.rewardvideo.JZDataSource
import com.halomobi.ssp.bussiness.module_video.rewardvideo.JZMediaManager
import com.halomobi.ssp.bussiness.module_video.rewardvideo.JZUserAction
import com.halomobi.ssp.bussiness.module_video.rewardvideo.JZUtils
import com.halomobi.ssp.bussiness.module_video.rewardvideo.Jzvd
import com.halomobi.ssp.framework.controller.AdController
import com.halomobi.ssp.framework.interfaces.IAdControl
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener
import com.halomobi.ssp.model.request.bean.AdBean
import com.ssp.sdk.R

class HmCustomRewardVideoAd(context: Context?) : Jzvd(context) {

    private var mImageAd: ImageView? = null
    var mIvVolumn: ImageView? = null
    var mTvClose: TextView? = null
    var mTvTime: TextView? = null
    var mProgressBar: ProgressBar
    private var isVolumn = true
    private val mContext = context as Activity?
    private var mAd: AdBean? = null
    private val mAdController: IAdControl? = AdController.getInstance(mContext)
    private val mRewardVideoListener: RewardVideoListener?
    private var isCallOnAdShow = false
    private var bannerView: View? = null
    private var relative_small: RelativeLayout? = null
    private var relative_big: RelativeLayout? = null
    private var relative_center: RelativeLayout? = null
    private var videoClose = false
    private var timer: CountDownTimer? = null
    private var isRewardCompleteCallBack: Boolean = false
    private var isPauseCountDown: Boolean = false


    override fun getLayoutId(): Int {
        return JZUtils.getId("hj_custom_video", "layout")
    }

    override fun onTouch(view: View, motionEvent: MotionEvent): Boolean {
        if (motionEvent.action == MotionEvent.ACTION_UP) {
            val screenSize = Utils.getScreenSize(true)
            val getY = motionEvent.y
            onclickDetail()
        }
        return false
    }

    override fun onClick(v: View) {
        val i = v.id
        if (i == JZUtils.getId("hj_iv_volume", "id")) {
            if (isVolumn) {
                JZMediaManager.instance().jzMediaInterface.setVolume(0f, 0f)
                reportTracker(ConstantPool.TrackerType.MUTE_TRACKER)
                (v as ImageView).setImageResource(JZUtils.getId("hj_mute", "drawable"))
                isVolumn = false
            } else {
                JZMediaManager.instance().jzMediaInterface.setVolume(1f, 1f)
                reportTracker(ConstantPool.TrackerType.UNMUTE_TRACKER)
                (v as ImageView).setImageResource(JZUtils.getId("hj_unmute", "drawable"))
                isVolumn = true
            }
        } else if (i == JZUtils.getId("hj_iv_start", "id")) {
            if (jzDataSource.urlsMap.isEmpty() || jzDataSource.currentUrl == null) {
                return
            }
            if (currentState == CURRENT_STATE_NORMAL) {
                startVideo()
                onEvent(JZUserAction.ON_CLICK_START_ICON)
            } else if (currentState == CURRENT_STATE_PLAYING) {
                onEvent(JZUserAction.ON_CLICK_PAUSE)
                JZMediaManager.pause()
            } else if (currentState == CURRENT_STATE_PAUSE) {
                onEvent(JZUserAction.ON_CLICK_RESUME)
                JZMediaManager.start()
                onStatePlaying()
            } else if (currentState == CURRENT_STATE_AUTO_COMPLETE) {
                onEvent(JZUserAction.ON_CLICK_START_AUTO_COMPLETE)
                startVideo()
            }
        } else if (i == JZUtils.getId("tv_close", "id")) {
            if (videoClose) {
                mRewardVideoListener?.onAdClose()
                mContext?.finish()
                LogUtils.d("AdType:" + mAd?.ad_type + "::Closed")
            } else {
                if (GlobalVariablePool.isCloseVideDialog == false && ConfigPool.AdShowTypeName == ConstantPool.AdType.REWARDVIDEO.adName) {
                    showTipsDialog()
                }
                if (GlobalVariablePool.isCloseFullVideDialog == false && ConfigPool.AdShowTypeName == ConstantPool.AdType.REWARDFULLVIDEO.adName) {
                    showTipsDialog()
                }

            }
        } else if (i == JZUtils.getId(
                "hj_tv_detail", "id"
            ) || i == JZUtils.getId(
                "hj_por_tv_detail", "id"
            ) || i == JZUtils.getId("hj_tv_sub_detail", "id")
        ) {
            onclickDetail()
        }
    }

    @SuppressLint("SetTextI18n", "UseKtx", "UseCompatLoadingForDrawables")
    private fun showTipsDialog() {
        val builder = AlertDialog.Builder(mContext, R.style.hl_dialog)
        val inflater = mContext?.layoutInflater
        val dialogLayout = inflater?.inflate(R.layout.hj_dialog_tips_rewardvideo, null, false)
        val mTipTitle = dialogLayout?.findViewById<TextView>(R.id.tv_tip_title)
        mTipTitle?.text = "仅需" + mTvTime?.text + "秒即可获得奖励"
        val mTipTitleContinue = dialogLayout?.findViewById<TextView>(R.id.tv_tip_title_continue)
        mTipTitleContinue?.text = "确定要退出么"
        val mEnSure = dialogLayout?.findViewById<TextView>(R.id.tv_ensure)
        mEnSure?.text = "继续观看"
        mEnSure?.setTextColor(Color.parseColor("#FFFFFF"))
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            mEnSure?.background = mContext?.getDrawable(R.drawable.hj_corner_blue_dialog)
        }
        val mCancel = dialogLayout?.findViewById<TextView>(R.id.tv_cancel)
        mCancel?.text = "关闭广告"
        mCancel?.setTextColor(Color.parseColor("#000000"))
        goOnPlayOnPause() //弹出是否关闭广告弹窗后暂停播放
        releaseTimer()
        builder.setCancelable(false)
        builder.setView(dialogLayout)
        val alertDialog = builder.create()
        alertDialog.window?.setLayout(100, 200)
        alertDialog.show()
        mEnSure?.setOnClickListener({
            goOnPlayOnResume() //弹出是否关闭广告弹窗后点击确定继续恢复播放
            isPauseCountDown = false
            startCountDown(mTvTime?.text.toString())
            alertDialog.dismiss()
        })
        mCancel?.setOnClickListener({
            mRewardVideoListener?.onAdClose()
            reportTracker(ConstantPool.TrackerType.CLOSE)
            resetVideo()//关闭广告后重置广告播放
            alertDialog.dismiss()
            mContext?.finish()
            LogUtils.d("AdType:" + mAd?.ad_type + "::Closed")
        })

    }

    private fun reportTracker(type: Int) {
        try {
            if (mAd != null) {
                mAd?.getTracks(type)?.let { ReportTrackerManager.instance?.reportTrack(it) }
                mAd?.trackerGroup?.remove(type)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    override fun setUp(jzDataSource: JZDataSource, screen: Int) {
        super.setUp(jzDataSource, screen)
    }

    override fun onStateError(what: Int, extra: Int) {
        val msg = "AdType:" + mAd?.ad_type + "AdPlayingFailed  what:" + what + " extra:" + extra
        LogUtils.d(msg)
        onCompletion()
        mRewardVideoListener?.onError(
            ConstantPool.EroType.PLAYINGERROR, msg
        )
        super.onStateError(what, extra)
    }

    override fun onStatePause() {
        reportTracker(ConstantPool.TrackerType.VIDEO_PAUSE_TRACKER)
        super.onStatePause()
    }

    override fun onStatePreparing() {
        mAd = HmRewardVideoManager.instance?.mAd
        startCountDown()
        super.onStatePreparing()
    }

    override fun onStatePlaying() {
        super.onStatePlaying()
        if (bannerView == null) {
            initBanner()
        }
        JZMediaManager.instance().jzMediaInterface.setVolume(1f, 1f)
        if (mRewardVideoListener != null && !isCallOnAdShow) {
            mRewardVideoListener.onAdShow()
            isCallOnAdShow = true
            LogUtils.d("AdType:" + mAd?.ad_type + "::AdShowSuccess")
        }
        reportTracker(ConstantPool.TrackerType.DISPLAY)
        reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_0_TRACKER)
        mProgressBar.visibility = GONE
    }

    //开始播放倒计时
    private fun startCountDown() {
        val duration = mAd?.reward_video?.videoDuration
        if (TextUtils.isEmpty(duration)) {
            return
        }
        if (duration != null) {
            timer = object : CountDownTimer(duration.toInt() * 1000L, 1000) {
                override fun onTick(millisUntilFinished: Long) {
                    mAd?.video_progress = duration.toInt()
                    mAd?.video_progress_ms = duration.toInt() * 1000
                    mTvTime?.text = (millisUntilFinished / 1000).toString()
                }

                override fun onFinish() {
                    mTvTime?.visibility = GONE
                    videoClose = true
                    mRewardVideoListener?.onRewardComplete()
                }
            }
            timer?.start()
        }

    }

    //中间暂停后重新开始播放倒计时
    private fun startCountDown(mDuration: String) {
        if (TextUtils.isEmpty(mDuration)) {
            return
        }
        Utils.postDelayed(DownCountTask(mDuration.toInt()), 1000)
    }

    //倒计时逻辑
    private inner class DownCountTask(countDownTime: Int) : Runnable {
        var innerCountDownTime = countDownTime
        override fun run() {
            if (!isPauseCountDown) {
                if (innerCountDownTime > 0) {
                    innerCountDownTime--
                    mTvTime?.text = innerCountDownTime.toString() // 更新UI显示剩余时间
                    mAd?.video_progress = innerCountDownTime
                    mAd?.video_progress_ms = innerCountDownTime * 1000
                    Utils.postDelayed(this, 1000) // 每秒更新一次
                } else {
                    // 倒计时结束后的操作
                    if (!isRewardCompleteCallBack) {
                        mTvTime?.visibility = GONE
                        videoClose = true
                        isRewardCompleteCallBack = true
                        mRewardVideoListener?.onRewardComplete()
                    }
                    Utils.removeCallbacks(this)// 倒计时结束，销毁Handler
                }
            } else {
                Utils.removeCallbacks(this)// 倒计时结束，销毁Handler
            }
        }
    }


    private fun initBanner() {
        if (mAd?.reward_video != null && !TextUtils.isEmpty(mAd?.reward_video?.title)) {
            val params = LayoutParams(LayoutParams.MATCH_PARENT, -1)
            params.gravity = Gravity.BOTTOM or Gravity.CENTER_HORIZONTAL

            if (AdBean.SCREEN_ORIENTATION_PORTRAIT == mAd?.reward_video?.orientation) {
                bannerView = LayoutInflater.from(context)
                    .inflate(JZUtils.getId("hj_banner_layout", "layout"), null)
                params.width = JZUtils.getScreenWidth(mContext)
                params.bottomMargin = 120
            } else {
                bannerView = LayoutInflater.from(context)
                    .inflate(JZUtils.getId("hj_banner_orien_layout", "layout"), null)
                params.width = JZUtils.getScreenWidth(mContext) / 2
                params.bottomMargin = 60
            }
            params.height = LayoutParams.WRAP_CONTENT
            relative_small = bannerView?.findViewById(JZUtils.getId("relative_small_banner", "id"))
            val icon = bannerView?.findViewById<ImageView>(JZUtils.getId("hj_iv_icon", "id"))
            val title = bannerView?.findViewById<TextView>(JZUtils.getId("hj_tv_title", "id"))
            val subTitle =
                bannerView?.findViewById<TextView>(JZUtils.getId("hj_tv_sub_title", "id"))
            val detail = bannerView?.findViewById<TextView>(JZUtils.getId("hj_tv_detail", "id"))
            detail?.setOnClickListener(this)
            relative_big = bannerView?.findViewById(JZUtils.getId("relative_big_banner", "id"))
            val icon_big =
                bannerView?.findViewById<ImageView>(JZUtils.getId("hj_por_iv_icon", "id"))
            val title_big =
                bannerView?.findViewById<TextView>(JZUtils.getId("hj_por_tv_title", "id"))
            val subTitle_big =
                bannerView?.findViewById<TextView>(JZUtils.getId("hj_por_tv_sub_title", "id"))
            val detail_big =
                bannerView?.findViewById<TextView>(JZUtils.getId("hj_por_tv_detail", "id"))
            detail_big?.setOnClickListener(this)
            relative_center =
                bannerView?.findViewById(JZUtils.getId("relative_center_banner", "id"))
            val detail_center =
                bannerView?.findViewById<TextView>(JZUtils.getId("hj_tv_sub_detail", "id"))
            detail_center?.setOnClickListener(this)
            if (!TextUtils.isEmpty(mAd?.reward_video?.title)) {
                title?.text = mAd?.reward_video?.title
                title_big?.text = mAd?.reward_video?.title
            }
            if (!TextUtils.isEmpty(mAd?.reward_video?.subTitle)) {
                subTitle?.text = mAd?.reward_video?.subTitle
                subTitle_big?.text = mAd?.reward_video?.subTitle
            }
            if (!TextUtils.isEmpty(mAd?.reward_video?.icon)) {
                ImageLoader.load(icon, mAd?.reward_video?.icon)
                ImageLoader.load(icon_big, mAd?.reward_video?.icon)
            }
            if (mAd?.interaction_type == 2) {
                relative_small?.setVisibility(VISIBLE)
                detail_big?.text = "立即下载"
            }
            addView(bannerView, params)
        }
    }

    private fun onclickDetail() {
        if (mAdController != null && mAd != null && mContext != null) {
            mContext.runOnUiThread(Runnable {
                mAdController.clickAd(mAd)
                if (mRewardVideoListener != null) {
                    mRewardVideoListener.onAdClick()
                    reportTracker(ConstantPool.TrackerType.VIDEO_CLICK_TRACKER)
                }
            })
        }
    }

    override fun onStateAutoComplete() {
        super.onStateAutoComplete()
    }

    override fun onProgress(progress: Int, position: Long, duration: Long) {
        if (mAd != null) {
            if (progress == 0) {
                reportTracker(ConstantPool.TrackerType.VIDEO_START_TRACKER)
            } else if (mAd?.is25Report != true && progress > 22 && progress < 28) {
                mRewardVideoListener?.onProgress(progress)//回调播放进度
                mAd?.is25Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_1_TRACKER)
            } else if (mAd?.is50Report != true && progress > 47 && progress < 53) {
                mRewardVideoListener?.onProgress(progress)//回调播放进度
                mAd?.is50Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_2_TRACKER)
            } else if (mAd?.is75Report != true && progress > 72 && progress < 78) {
                mRewardVideoListener?.onProgress(progress)//回调播放进度
                mAd?.is75Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_3_TRACKER)
            } else if (progress >= 99) {
                mRewardVideoListener?.onProgress(progress)//回调播放进度
                reportTracker(ConstantPool.TrackerType.VIDEO_COMPLETE_TRACKER)
            }
        }
    }


    override fun onCompletion() {
        if (mVideoStateChangeListener != null) {
            mVideoStateChangeListener?.videoClose()
        }
        if (mAd != null && relative_small != null && relative_big != null && relative_center != null) {
            if (mAd?.interaction_type == 2) {
                relative_small?.visibility = GONE
                relative_big?.visibility = VISIBLE
            } else {
                relative_center?.visibility = VISIBLE
            }
        }
        super.onCompletion()
        mVideoStateChangeListener = null
    }

    override fun onAutoCompletion() {
        reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_4_TRACKER)
        reportTracker(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER)
        if (mAd != null && relative_small != null && relative_big != null && relative_center != null) {
            if (mAd?.interaction_type == 2) {
                relative_small?.visibility = GONE
                relative_big?.visibility = VISIBLE
            } else {
                relative_center?.visibility = VISIBLE
            }
        }
        mRewardVideoListener?.onPlayEnd()
        super.onAutoCompletion()
    }


    private val mClickAdStateChangListener: ClickAdStateChangListener =
        object : ClickAdStateChangListener {
            override fun onClickAdStateChang(clickAdState: Int) {
                when (clickAdState) {
                    ClickAdStateChangListener.STATE_WEB_OPEN -> {
                        releaseTimer()
                        goOnPlayOnPause()
                    }

                    ClickAdStateChangListener.STATE_WEB_CLOSE -> {
                        isPauseCountDown = false
                        startCountDown(mTvTime?.text.toString())
                        goOnPlayOnResume()
                    }

                    else -> {}
                }
            }
        }


    init {
        mAdController?.setClickAdListener(mClickAdStateChangListener)
        mIvVolumn = findViewById(JZUtils.getId("hj_iv_volume", "id"))
        mProgressBar = findViewById(JZUtils.getId("hj_progress", "id"))
        mTvTime = findViewById(JZUtils.getId("tv_time", "id"))
        mTvClose = findViewById(JZUtils.getId("tv_close", "id"))
        mImageAd = findViewById(JZUtils.getId("image_ad", "id"))
        mIvVolumn?.setOnClickListener(this)
        mTvClose?.setOnClickListener(this)
        mRewardVideoListener = HmRewardVideoManager.instance?.listener
        val logo_params = RelativeLayout.LayoutParams(100, 50)
        logo_params.addRule(ALIGN_PARENT_BOTTOM)
        logo_params.addRule(ALIGN_PARENT_RIGHT)
        logo_params.bottomMargin = 40
        logo_params.rightMargin = 40
        mImageAd?.layoutParams = logo_params
        mImageAd?.visibility = VISIBLE
    }

    fun releaseTimer() {
        if (timer != null) {
            timer?.cancel()
        }
        isPauseCountDown = true
    }

    interface VideoStateChangeListener {
        fun videoClose()
    }


    //设置是否取消关闭按钮
    fun setCloseBtnVisible(isShow: Boolean) {
    }

    companion object {
        private var mVideoStateChangeListener: VideoStateChangeListener? = null

        @JvmStatic
        fun startFullscreen(
            context: Context?,
            classFullName: Class<*>?,
            url: String?,
            title: String?,
            orientation: String?,
            listener: VideoStateChangeListener?
        ) {
            mVideoStateChangeListener = listener
            startFullscreen(
                context, classFullName,
                JZDataSource(
                    url,
                    title
                ), orientation
            )
        }
    }
}
