package com.halomobi.ssp.bussiness.module_sdk.normal

import android.content.Context
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_sdk.listener.RewardVideoListener
import com.halomobi.ssp.framework.Abstract.AbstractVideoAd
import com.halomobi.ssp.model.request.bean.AdBean

/**
 *  激励视频
 */
class HmFullRewardVideoAd(context: Context?, adSlotId: String?, listener: RewardVideoListener?) :
    AbstractVideoAd(context, adSlotId, ConstantPool.AdType.REWARDFULLVIDEO, listener) {


    init {
        Utils.putSpInt(ConstantPool.AdType.REWARDFULLVIDEO.type)
    }
    /**
     * 加载广告
     */
    fun loadAd() {
        if (mAdController != null && HmRewardVideoManager.instance?.isShow != true) {
            HmRewardVideoManager.instance?.isReady = false
            HmRewardVideoManager.instance?.listener = mRewardVideoListener
            mAdController?.requestAd(mAdParameter, this)
        } else {
            if (mRewardVideoListener != null) {
                mRewardVideoListener?.onError(
                    ConstantPool.EroType.SHOWINGERROR,
                    "视频播放中,请关闭后再请求下一条."
                )
            }
        }
    }

    val ecpm: Int
        get() {
            if (HmRewardVideoManager.instance?.mAd == null) return 0
            return HmRewardVideoManager.instance?.mAd?.price?:0
        }

    val isReady: Boolean
        /**
         * 判断广告是否可以进行展示
         */
        get() = HmRewardVideoManager.instance?.isReady == true

    /**
     * 展示广告.
     */
    fun show() {
        showAd()
    }

//    override fun onFloatAdReach(adInfoList: List<AdBean?>?) {
//    }

    override fun onNativeAdReach(adInfoList: List<AdBean?>?) {
        TODO("Not yet implemented")
    }

}
