package com.halomobi.ssp.bussiness.module_sdk.normal

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.graphics.Color
import android.hardware.Sensor
import android.hardware.SensorEvent
import android.hardware.SensorEventListener
import android.hardware.SensorManager
import android.provider.ContactsContract.CommonDataKinds.Im
import android.text.TextUtils
import android.util.DisplayMetrics
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.widget.FrameLayout
import android.widget.FrameLayout.LayoutParams
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import com.bumptech.glide.util.Util
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.base.utils.ToolsUtils
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.base.utils.Utils.post
import com.halomobi.ssp.base.utils.Utils.runInMainThread
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeAdListener
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeResponse
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JzvdStd
import com.halomobi.ssp.framework.Abstract.AbsNormalAd
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener
import com.halomobi.ssp.model.request.bean.AdBean
import com.ssp.sdk.R
import kotlin.math.abs


class HmNativeAd(activity: Activity?, adSlotId: String?, private val mDirectionType: Int) :
    AbsNormalAd(activity, adSlotId, ConstantPool.AdType.NATIVE), ClickAdStateChangListener {
    private var mNativeListener: NativeAdListener? = null

    private var lastUpdate: Long = 0

    private var lastX = 0f
    private var lastY = 0f
    private var lastZ = 0f

    private var iv_shake: ImageView? = null

    private var response: NativeResponse? = null

    private var inflate: View? = null


    private var isShow = false
    private var sensorManager: SensorManager? = null
    private var accelerometer: Sensor? = null

    private var imageViews: Array<ImageView>? = null

    private var nativeResponse: NativeResponse? = null

    private var mActivity: Activity? = null

    private var lastClickTime: Long = 0

    override fun createAdView(context: Context?): AbsAdView? {
        return null
    }

    override fun onAdClose() {
    }

    val ecpm: Int?
        get() {
            if (nativeResponse == null) return 0
            return nativeResponse?.price
        }

    public override fun nativeResponseSuccess(list: List<NativeResponse?>?) {
        nativeResponse = list?.get(0)
        post(Runnable {
            if (!list.isNullOrEmpty()) {
                val hmNativeView = HmNativeView(mActivity)
                mNativeListener?.let { hmNativeView.showView(list, it) }
                mNativeListener?.onAdReach(list, hmNativeView)
            } else {
                mNativeListener?.onAdError("广告返回为空", ConstantPool.EroType.BACK_EMPTY)
            }
        })
    }

    override fun onAdError(errorMsg: String?, errorCode: Int) {
        runInMainThread(Runnable {
            if (mNativeListener != null) {
                mNativeListener?.onAdError(errorMsg, errorCode)
            }
        })

    }

    fun requestAd(adListener: NativeAdListener?) {
        mNativeListener = adListener
        super.requestAd(null)
    }


    override fun onClickAdStateChang(clickAdState: Int) {
        when (clickAdState) {
            ClickAdStateChangListener.STATE_WEB_OPEN -> {}
            ClickAdStateChangListener.STATE_OPTION_DIALOG_OPEN -> {}
            ClickAdStateChangListener.STATE_WEB_LOAD_DEEPLINK -> {}
            ClickAdStateChangListener.STATE_WEB_CLOSE -> {
            }

            ClickAdStateChangListener.STATE_OPTION_DIALOG_CANCEL, ClickAdStateChangListener.STATE_OPTION_DIALOG_CONFIRM -> {}
            else -> {}
        }
    }

    //设置是否取消关闭按钮
    fun setCloseBtnVisible(isShow: Boolean) {
        adInfo.isCloseBtnVisible = isShow
    }


    private inner class HmNativeView(context: Context?) : RelativeLayout(context) {
        init {
            isShow = false
            if (mDirectionType == 1) {
                inflate = LayoutInflater.from(context).inflate(
                    R.layout.hj_native_item_imag_left, this
                )
            } else if (mDirectionType == 2) {
                inflate = LayoutInflater.from(context).inflate(
                    R.layout.hj_native_item_imag_right, this
                )
            } else if (mDirectionType == 3) {
                inflate = LayoutInflater.from(context).inflate(
                    R.layout.hj_native_item_imag_single, this
                )
            } else if (mDirectionType == 4) {
                inflate = LayoutInflater.from(context).inflate(
                    R.layout.hj_native_item_imag_single, this
                )
            }
            sensorManager = context?.getSystemService(Context.SENSOR_SERVICE) as SensorManager
            accelerometer = sensorManager?.getDefaultSensor(Sensor.TYPE_ACCELEROMETER)
            sensorManager?.registerListener(
                sensorEventListener, accelerometer, SensorManager.SENSOR_DELAY_NORMAL
            )
        }

        @SuppressLint("CutPasteId")
        fun showView(parseData: List<NativeResponse?>?, mNativeListener: NativeAdListener) {
            response = parseData?.get(0)
            val relayout = inflate?.findViewById<RelativeLayout>(R.id.relativelayout)
            var imageView: View? = inflate?.findViewById<RadiusImageView>(R.id.iv_cion1)
            iv_shake = inflate?.findViewById(R.id.iv_shake)
            val tv_item_linear = inflate?.findViewById<LinearLayout>(R.id.tv_item_linear)
            val iv_close = inflate?.findViewById<ImageView>(R.id.iv_close)
            val title = inflate?.findViewById<TextView>(R.id.tv_item_title)
            val subTitle = inflate?.findViewById<TextView>(R.id.tv_item_details)
            val logo_item_linear = inflate?.findViewById<LinearLayout>(R.id.logo_item_linear)
            title?.textSize = 14f
            subTitle?.textSize = 12f
            //设定左图右文布局宽高显示
            if (mDirectionType == 1) {
                relayout?.layoutParams =
                    LayoutParams(Utils.getScreenSize(true)[0], Utils.getScreenSize(true)[1].div(7))
                when (response?.adInfo?.creative_type) {
                    AdBean.CRE_TYPE_IMAGE -> {
                        imageView?.layoutParams = relayout?.layoutParams?.width?.div(2)
                            ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                        response?.setImageBindDataProxy { imageUrls ->
                            imageViews = arrayOf((imageView as ImageView)) // 使用自定义网络图片加载框架
                            if (imageUrls != null) {
                                for (i in imageUrls.indices) {
                                    response?.loadImage(imageViews?.get(i), imageUrls[i])
                                }
                            }
                            imageViews
                        }
                    }

                    AdBean.CRE_TYPE_VIDEO -> {
                        //视频广告类型
                        imageView = (inflate?.findViewById<JzvdStd>(R.id.iv_video))
                        imageView?.layoutParams = relayout?.layoutParams?.width?.div(2)
                            ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                        imageView?.visibility = VISIBLE
                        imageView?.mWidth = Utils.getScreenSize(true)[0].div(2)
                        imageView?.mHeight = Utils.getScreenSize(true)[1].div(7)
                        imageView?.setUp(response?.adInfo?.reward_video?.videoUrl, "")
                        imageView?.setAdBean(response?.adInfo)
                        imageView?.startVideo()
                    }

                }

                // 设置iv_shake相对于imageview居中显示
                iv_shake?.visibility = VISIBLE
                val params: LayoutParams? = imageView?.layoutParams?.height?.div(2)?.let {
                    imageView?.layoutParams?.width?.div(2)?.let { it1 -> LayoutParams(it1, it) }
                }
                params?.leftMargin = Utils.getScreenSize(true)[0].div(8)
                params?.addRule(CENTER_VERTICAL)
                iv_shake?.layoutParams = params

                //title描述
                val tv_item_params =
                    LayoutParams(Utils.getScreenSize(true)[0].div(2), LayoutParams.WRAP_CONTENT)
                imageView?.id?.let { tv_item_params.addRule(RIGHT_OF, it) }
                tv_item_linear?.layoutParams = tv_item_params

                //logo
                val logo_params = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
                imageView?.let { logo_params.addRule(RIGHT_OF, it.id) }
                logo_params.addRule(ALIGN_PARENT_BOTTOM)
                logo_item_linear?.layoutParams = logo_params

                //close关闭
                val close_params =
                    LayoutParams(50, 50)
                close_params.addRule(ALIGN_PARENT_BOTTOM)
                close_params.addRule(ALIGN_PARENT_END)
                iv_close?.layoutParams = close_params
            }

            //设置左文有图布局宽高显示
            if (mDirectionType == 2) {
                relayout?.layoutParams =
                    LayoutParams(Utils.getScreenSize(true)[0], Utils.getScreenSize(true)[1].div(7))
                when (response?.adInfo?.creative_type) {
                    AdBean.CRE_TYPE_IMAGE -> {
                        val imageView_params = relayout?.layoutParams?.width?.div(2)
                            ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                        imageView_params?.addRule(ALIGN_PARENT_END)
                        imageView?.layoutParams = imageView_params
                        response?.setImageBindDataProxy { imageUrls ->
                            imageViews = arrayOf((imageView as ImageView)) // 使用自定义网络图片加载框架
                            if (imageUrls != null) {
                                for (i in imageUrls.indices) {
                                    response?.loadImage(imageViews?.get(i), imageUrls[i])
                                }
                            }
                            imageViews
                        }
                    }

                    AdBean.CRE_TYPE_VIDEO -> {
                        //视频广告类型
                        imageView = (inflate?.findViewById<JzvdStd>(R.id.iv_video))
                        val imageView_params = relayout?.layoutParams?.width?.div(2)
                            ?.let { LayoutParams(it, Utils.getScreenSize(true)[1].div(7)) }
                        imageView_params?.addRule(ALIGN_PARENT_END)
                        imageView?.layoutParams = imageView_params
                        imageView?.visibility = VISIBLE
                        imageView?.mWidth = Utils.getScreenSize(true)[0].div(2)
                        imageView?.mHeight = Utils.getScreenSize(true)[1].div(7)
                        imageView?.setUp(response?.adInfo?.reward_video?.videoUrl, "")
                        imageView?.setAdBean(response?.adInfo)
                        imageView?.startVideo()
                    }

                }

                // 设置iv_shake相对于imageview居中显示
                iv_shake?.visibility = VISIBLE
                val iv_shake_params: LayoutParams? = imageView?.layoutParams?.height?.div(2)?.let {
                    imageView?.layoutParams?.width?.div(2)?.let { it1 -> LayoutParams(it1, it) }
                }
                iv_shake_params?.leftMargin = Utils.getScreenSize(true)[0].div(8).times(5)
                iv_shake_params?.addRule(CENTER_VERTICAL)
                iv_shake?.layoutParams = iv_shake_params

                //title描述
                val tv_item_params =
                    LayoutParams(Utils.getScreenSize(true)[0].div(2), LayoutParams.WRAP_CONTENT)
                tv_item_linear?.layoutParams = tv_item_params

                //logo
                val logo_params = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
                logo_params.addRule(ALIGN_PARENT_LEFT)
                logo_params.addRule(ALIGN_PARENT_BOTTOM)
                logo_item_linear?.layoutParams = logo_params

                //close关闭
                val close_params =
                    LayoutParams(50, 50)
                close_params.addRule(ALIGN_PARENT_BOTTOM)
                imageView?.let { close_params.addRule(LEFT_OF, it.id) }
                iv_close?.layoutParams = close_params

            }

            if (mDirectionType == 3) {
                relayout?.layoutParams = LayoutParams(
                    Utils.getScreenSize(true)[0], Utils.getScreenSize(true)[1].div(3)
                )
                when (response?.adInfo?.creative_type) {
                    AdBean.CRE_TYPE_IMAGE -> {
                        imageView?.layoutParams = relayout?.layoutParams?.height?.div(5)?.times(4)
                            ?.let { LayoutParams(Utils.getScreenSize(true)[0], it) }
                        response?.setImageBindDataProxy { imageUrls ->
                            imageViews = arrayOf((imageView as ImageView)) // 使用自定义网络图片加载框架
                            if (imageUrls != null) {
                                for (i in imageUrls.indices) {
                                    response?.loadImage(imageViews?.get(i), imageUrls[i])
                                }
                            }
                            imageViews
                        }
                    }
                    AdBean.CRE_TYPE_VIDEO -> {
                        //视频广告类型
                        imageView = (inflate?.findViewById<JzvdStd>(R.id.iv_video))
                        imageView?.layoutParams = relayout?.layoutParams?.height?.div(5)?.times(4)
                            ?.let { LayoutParams(Utils.getScreenSize(true)[0],it) }
                        imageView?.visibility = VISIBLE
                        imageView?.mWidth = Utils.getScreenSize(true)[0]
                        imageView?.mHeight = Utils.getScreenSize(true)[1].div(2).div(3).times(2)
                        imageView?.setUp(response?.adInfo?.reward_video?.videoUrl, "")
                        imageView?.setAdBean(response?.adInfo)
                        imageView?.startVideo()
                    }
                }


                // 设置iv_shake相对于imageview居中显示
                iv_shake?.visibility = VISIBLE
                iv_shake?.layoutParams = imageView?.layoutParams?.height?.div(3)?.let {
                    imageView?.layoutParams?.width?.div(3)?.let { it1 -> LayoutParams(it1, it) }
                }
                val iv_shake_params: LayoutParams? = iv_shake?.layoutParams?.width?.let {
                    iv_shake?.layoutParams?.height?.let { it1 ->
                        LayoutParams(
                            it, it1
                        )
                    }
                }
                iv_shake_params?.leftMargin = ((iv_shake?.layoutParams?.width?.let {
                    imageView?.layoutParams?.width?.minus(it)
                })?.div(2)) ?: 0
                iv_shake_params?.topMargin = ((iv_shake?.layoutParams?.height?.let {
                    imageView?.layoutParams?.height?.minus(it)
                })?.div(2)) ?: 0
                iv_shake?.layoutParams = iv_shake_params

                //title描述
                val tv_item_params= LayoutParams(LayoutParams.WRAP_CONTENT,  LayoutParams.WRAP_CONTENT)
                tv_item_params.addRule(ALIGN_PARENT_BOTTOM)
                tv_item_linear?.layoutParams = tv_item_params

                //logo
                val logo_params = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
                logo_params.addRule(ALIGN_PARENT_RIGHT)
                logo_params.addRule(ALIGN_PARENT_BOTTOM)
                logo_item_linear?.layoutParams = logo_params

                //close关闭
                val close_params =
                    LayoutParams(50, 50)
                close_params.addRule(ALIGN_PARENT_RIGHT)
                iv_close?.layoutParams = close_params
            }

            if (mDirectionType == 4) {
                tv_item_linear?.visibility= GONE
                relayout?.layoutParams = LayoutParams(
                    Utils.getScreenSize(true)[0], Utils.getScreenSize(true)[1].div(3)
                )
                when (response?.adInfo?.creative_type) {
                    AdBean.CRE_TYPE_IMAGE -> {
                        imageView?.layoutParams = relayout?.layoutParams?.height
                            ?.let { LayoutParams(Utils.getScreenSize(true)[0], it) }
                        response?.setImageBindDataProxy { imageUrls ->
                            imageViews = arrayOf((imageView as ImageView)) // 使用自定义网络图片加载框架
                            if (imageUrls != null) {
                                for (i in imageUrls.indices) {
                                    response?.loadImage(imageViews?.get(i), imageUrls[i])
                                }
                            }
                            imageViews
                        }
                    }
                    AdBean.CRE_TYPE_VIDEO -> {
                        //视频广告类型
                        imageView = (inflate?.findViewById<JzvdStd>(R.id.iv_video))
                        imageView?.layoutParams = relayout?.layoutParams?.height
                            ?.let { LayoutParams(Utils.getScreenSize(true)[0],it) }
                        imageView?.visibility = VISIBLE
                        imageView?.mWidth = Utils.getScreenSize(true)[0]
                        imageView?.mHeight = Utils.getScreenSize(true)[1].div(2).div(3).times(2)
                        imageView?.setUp(response?.adInfo?.reward_video?.videoUrl, "")
                        imageView?.setAdBean(response?.adInfo)
                        imageView?.startVideo()
                    }
                }

                // 设置iv_shake相对于imageview居中显示
                iv_shake?.visibility = VISIBLE
                iv_shake?.layoutParams = imageView?.layoutParams?.height?.div(3)?.let {
                    imageView.layoutParams?.width?.div(3)?.let { it1 -> LayoutParams(it1, it) }
                }
                val iv_shake_params: LayoutParams? = iv_shake?.layoutParams?.width?.let {
                    iv_shake?.layoutParams?.height?.let { it1 ->
                        LayoutParams(
                            it, it1
                        )
                    }
                }
                iv_shake_params?.leftMargin = ((iv_shake?.layoutParams?.width?.let {
                    imageView?.layoutParams?.width?.minus(it)
                })?.div(2)) ?: 0
                iv_shake_params?.topMargin = ((iv_shake?.layoutParams?.height?.let {
                    imageView?.layoutParams?.height?.minus(it)
                })?.div(2)) ?: 0
                iv_shake?.layoutParams = iv_shake_params


                //logo
                val logo_params = LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT)
                logo_params.addRule(ALIGN_PARENT_RIGHT)
                logo_params.addRule(ALIGN_PARENT_BOTTOM)
                logo_item_linear?.layoutParams = logo_params

                //close关闭
                val close_params =
                    LayoutParams(50, 50)
                close_params.addRule(ALIGN_PARENT_RIGHT)
                iv_close?.layoutParams = close_params
            }



            title?.text = response?.title
            subTitle?.text = response?.subTitle
            //广告区域点击
            inflate?.setOnClickListener {
                response?.handleClick(inflate, true)
                mNativeListener.onAdClick()
            }

            iv_close?.setOnClickListener {
                inflate?.visibility = GONE
                response?.handleClose()
                mNativeListener.onAdClose()
                LogUtils.d("AdType:" + response?.type + "::AdClosed")
                if (sensorManager != null) {
                    sensorManager?.unregisterListener(sensorEventListener) //广告关闭时摇一摇监听关闭
                }
            }

            val relativeLayout = inflate?.findViewById<RelativeLayout>(R.id.relativelayout)
            val viewTreeObserver = relativeLayout?.viewTreeObserver
            viewTreeObserver?.addOnGlobalLayoutListener {
                val viewCovered = Utils.isViewCovered(relativeLayout, 0.3f)
                if (!viewCovered && !isShow) {
                    isShow = true
                    response?.handleShow()
                    mNativeListener.onAdShow()
                    LogUtils.d("AdType:" + response?.type + "::AdShowSuccess")
                }
            }

            viewTreeObserver?.addOnScrollChangedListener {
                val viewCovered = Utils.isViewCovered(relativeLayout, 0.3f)
                if (!viewCovered && !isShow) {
                    isShow = true
                    response?.handleShow()
                    mNativeListener.onAdShow()
                    LogUtils.d("AdType:" + response?.type + "::AdShowSuccess")
                }
            }
        }
    }


    private val sensorEventListener: SensorEventListener = object : SensorEventListener {
        override fun onSensorChanged(event: SensorEvent) {
            val curTime = System.currentTimeMillis()
            if ((curTime - lastUpdate) > TIME_THRESHOLD) {
                val diffTime = (curTime - lastUpdate)
                lastUpdate = curTime

                val x = event.values[0]
                val y = event.values[1]
                val z = event.values[2]

                val speed =
                    (abs((x + y + z - lastX - lastY - lastZ).toDouble()) / diffTime * 10000).toFloat()
                if (speed >= 0) { // 摇动的判定条件
                    // 切换图片逻辑
                    changeImage()
                }
                if (speed > FORCE_THRESHOLD && mActivity?.isFinishing == false && mActivity?.window?.decorView?.windowVisibility == View.VISIBLE && !isQuickClick()) {
                    //摇一摇触发点击
                    response?.handleClick(inflate, true)
                    mNativeListener?.onAdClick()
                }

                lastX = x
                lastY = y
                lastZ = z
            }
        }

        override fun onAccuracyChanged(sensor: Sensor, accuracy: Int) {
            // 可以选择忽略这个方法，因为我们不关心传感器精度变化。
        }
    }

    fun isQuickClick(): Boolean {
        val currentTime: Long = System.currentTimeMillis()
        if (currentTime - lastClickTime > 1000) {
            lastClickTime = currentTime;
            return false
        }
        return true
    }

    init {
        Utils.putSpInt(ConstantPool.AdType.NATIVE.type)
        setClickAdListener(this)
    }

    @SuppressLint("UseCompatLoadingForDrawables")
    private fun changeImage() {
        if (iv_shake?.drawable?.current?.constantState === mActivity?.resources?.getDrawable(R.drawable.hj_shake_one)?.current?.constantState) {
            iv_shake?.setImageResource(R.drawable.hj_shake_two) // 切换到第二个图片资源
        } else {
            iv_shake?.setImageResource(R.drawable.hj_shake_one) // 切换回第一个图片资源
        }
    }

    companion object {
        private const val FORCE_THRESHOLD = 170

        private const val TIME_THRESHOLD = 100
    }

    init {
        mActivity = activity
    }
}
