package com.halomobi.ssp.bussiness.module_sdk.normal

import com.danikula.videocache.CacheListener
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager
import com.halomobi.ssp.bussiness.module_sdk.listener.RewardVideoListener
import com.halomobi.ssp.framework.listener.TrackerTaskListener
import com.halomobi.ssp.model.request.bean.AdBean


class HmRewardVideoManager {
    var listener: RewardVideoListener? = null
    @JvmField
    var mAd: AdBean? = null
    @JvmField
    var isShow: Boolean = false
    @JvmField
    var isReady: Boolean = false

    fun onDestroy() {
        listener = null
        mAd = null
        isShow = false
        isReady = false
    }

    @JvmField
    var mCacheListener: CacheListener = CacheListener { file, s, i -> //            LogUtils.d("RewardVideo:progress: " + i);
        if (mAd != null && mAd?.isCached != true && i == 100 && listener != null) {
            mAd?.isCached = true
            listener?.onCacheSuccess()
            if (mAd?.getTracks(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER)?.isNotEmpty() == true) {
                ReportTrackerManager.instance?.reportTrack(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER, object : TrackerTaskListener {
                        override fun onTrackersReturn() {
                        }
                    }, mAd?.getTracks(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER)
                )
                mAd?.trackerGroup?.remove(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER)
            }
        }
    }

    companion object {
        private var mInstance: HmRewardVideoManager? = null
        @JvmStatic
        val instance: HmRewardVideoManager?
            get() {
                if (mInstance == null) {
                    synchronized(HmRewardVideoManager::class.java) {
                        if (mInstance == null) {
                            mInstance = HmRewardVideoManager()
                        }
                    }
                }
                return mInstance
            }
    }
}
