package com.halomobi.ssp.bussiness.module_sdk.normal

import android.app.Activity
import android.content.Context
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.base.utils.Utils.post
import com.halomobi.ssp.base.utils.Utils.runInMainThread
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeAdListener
import com.halomobi.ssp.bussiness.module_sdk.listener.NativeResponse
import com.halomobi.ssp.framework.Abstract.AbsNormalAd
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener

class HmUnifiedNativeAd(activity: Activity?, adSlotId: String?) :
    AbsNormalAd(activity, adSlotId, ConstantPool.AdType.UNIFIEDNATIVE),
    ClickAdStateChangListener {
    private var mNativeListener: NativeAdListener? = null

    private var nativeResponse: NativeResponse? = null


    init {
        Utils.putSpInt(ConstantPool.AdType.UNIFIEDNATIVE.type)
        setClickAdListener(this)
    }

    override fun createAdView(context: Context?): AbsAdView? {
        return null
    }

    override fun onAdClose() {
    }

    val ecpm: Int?
        get() {
            if (nativeResponse == null) return 0
            return nativeResponse?.price
        }


    public override fun nativeResponseSuccess(list: List<NativeResponse?>?) {
        nativeResponse = list?.get(0)
        post(Runnable {
            if (list?.isNotEmpty() == true) {
                mNativeListener?.onAdReach(list)
            } else {
                mNativeListener?.onAdError(
                    "广告返回为空",
                    ConstantPool.EroType.BACK_EMPTY
                )
            }
        })
    }

    override fun onAdError(errorMsg: String?, errorCode: Int) {
        runInMainThread(Runnable {
            if (mNativeListener != null) {
                mNativeListener?.onAdError(errorMsg, errorCode)
            }
        })
    }

    fun requestAd(adListener: NativeAdListener?) {
        mNativeListener = adListener
        super.requestAd(null)
    }

    override fun onClickAdStateChang(clickAdState: Int) {
        when (clickAdState) {
            ClickAdStateChangListener.STATE_WEB_OPEN -> {}
            ClickAdStateChangListener.STATE_OPTION_DIALOG_OPEN -> {}
            ClickAdStateChangListener.STATE_WEB_LOAD_DEEPLINK -> {}
            ClickAdStateChangListener.STATE_WEB_CLOSE -> {
            }
            ClickAdStateChangListener.STATE_OPTION_DIALOG_CANCEL, ClickAdStateChangListener.STATE_OPTION_DIALOG_CONFIRM -> {}else -> {}
        }
    }



}
