package com.halomobi.ssp.bussiness.module_sdk.normal

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Canvas
import android.graphics.Path
import android.util.AttributeSet
import android.widget.ImageView

@SuppressLint("AppCompatCustomView")
class RadiusImageView : ImageView {
    /**
     * 圆角大小
     */
    private var radiusSize = dip2px(context, 4f)

    constructor(context: Context?) : super(context, null)

    constructor(context: Context?, attrs: AttributeSet?) : super(context, attrs, 0)

    constructor(context: Context?, attrs: AttributeSet?, defStyleAttr: Int) : super(
        context,
        attrs,
        defStyleAttr
    ) {
        init()
    }

    private fun init() {
    }

    /**
     * 设置圆角大小,设置后需要再次刷新下当前view，使用invalidate()或者postInvalidate()刷新都可以的
     *
     * @param size dp值
     */
    fun setRadiusSize(size: Int) {
        radiusSize = dip2px(context, size.toFloat())
        invalidate()
    }

    override fun onDraw(canvas: Canvas) {
        if (width > radiusSize && height > radiusSize) {
            @SuppressLint("DrawAllocation") val path = Path()
            path.moveTo(radiusSize.toFloat(), 0f)
            path.lineTo((width - radiusSize).toFloat(), 0f)
            path.quadTo(width.toFloat(), 0f, width.toFloat(), radiusSize.toFloat())
            path.lineTo(width.toFloat(), (height - radiusSize).toFloat())
            path.quadTo(
                width.toFloat(),
                height.toFloat(),
                (width - radiusSize).toFloat(),
                height.toFloat()
            )
            path.lineTo(radiusSize.toFloat(), height.toFloat())
            path.quadTo(0f, height.toFloat(), 0f, (height - radiusSize).toFloat())
            path.lineTo(0f, radiusSize.toFloat())
            path.quadTo(0f, 0f, radiusSize.toFloat(), 0f)
            canvas.clipPath(path)
        }
        super.onDraw(canvas)
    }

    companion object {
        fun dip2px(context: Context, dpValue: Float): Int {
            val scale = context.resources.displayMetrics.density
            return (dpValue * scale + 0.5f).toInt()
        }
    }
}
