package com.halomobi.ssp.bussiness.module_sdk.view.web

import android.annotation.SuppressLint
import android.content.ActivityNotFoundException
import android.content.Context
import android.content.Intent
import android.content.pm.PackageManager
import android.graphics.Bitmap
import android.graphics.Color
import android.graphics.drawable.Drawable
import android.net.Uri
import android.net.http.SslError
import android.os.Build
import android.text.TextUtils
import android.util.DisplayMetrics
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.webkit.DownloadListener
import android.webkit.SslErrorHandler
import android.webkit.WebChromeClient
import android.webkit.WebResourceError
import android.webkit.WebResourceRequest
import android.webkit.WebSettings
import android.webkit.WebSettings.ZoomDensity
import android.webkit.WebView
import android.webkit.WebView.HitTestResult
import android.webkit.WebViewClient
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.ProgressBar
import com.halomobi.ssp.base.utils.DrawableUtils
import com.halomobi.ssp.base.utils.KeyUtil
import com.halomobi.ssp.base.utils.LogUtils
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_download.DownLoadManager
import com.halomobi.ssp.bussiness.module_download.bean.AppInfo
import com.halomobi.ssp.bussiness.module_download.bean.DownloadItem
import com.halomobi.ssp.bussiness.module_download.listener.DownloadStateListener
import com.halomobi.ssp.model.request.bean.AdBean
import com.halomobi.ssp.model.request.config.SDKInfo
import java.io.IOException
import java.net.URISyntaxException
import androidx.core.graphics.toColorInt
import androidx.core.net.toUri

class BrowserPagNative(
    context: Context?,
    private var pageStateListener: BrowserPageStateListener?,
    adInfo: AdBean?
) :
    View.OnClickListener {
    private var mAd: AdBean? = null

    private var mCx: Context? = null
    private val tableBar_h =
        (Utils.getScreenSize(context, true)[0] * 0.14).toInt()
    var webPage: ViewGroup? = null

    /**
     * 进度条
     */
    private var progressBar: ProgressBar? = null

    /**
     * web页
     */
    private var mWebView: WebView? = null

    /**
     * 错误页面
     */
    private var mEroView: ViewGroup? = null

    private var dUrls: ArrayList<String>? = null

    init {
        try {
            mCx = context
            mAd = adInfo
            dUrls = ArrayList()
            initView()
        } catch (e: IOException) {
            e.printStackTrace()
        }
    }

    fun setPageStateListener(closeListener: BrowserPageStateListener?) {
        this.pageStateListener = closeListener
    }

    fun getWebPage(): View? {
        return webPage
    }

    private fun initView() {
        // 最外层布局
        val pagLayout = mCx?.let { FrameLayout(it) }
        // 内容页
        val layoutParams = FrameLayout.LayoutParams(-1, -1)
        layoutParams.setMargins(0, 0, 0, tableBar_h)
        pagLayout?.addView(createContentView(), layoutParams)
        // 错误页面
//        pagLayout?.addView(createErrorView(), FrameLayout.LayoutParams(-1, -1))
        // 底部导航
        pagLayout?.addView(
            createTableBar(),
            FrameLayout.LayoutParams(-1, tableBar_h, Gravity.BOTTOM)
        )
        webPage = pagLayout
    }

    @SuppressLint("NewApi")
    private fun createErrorView(): View? {
        try {
            this.mEroView = mCx?.let { FrameLayout(it) }
            (mEroView as FrameLayout).setBackgroundColor("#ffffff".toColorInt())
            (mEroView as FrameLayout).setVisibility(View.INVISIBLE)
            val errorImag = ImageView(mCx)
            errorImag.setOnClickListener(this)
            errorImag.tag = ERO_IMAGE
            val `is` = mCx?.assets?.open(String.format(ICON_PATH, ERO_IMAGE))
            val background = Drawable.createFromStream(`is`, ERO_IMAGE)
            errorImag.background = background
            val d = (tableBar_h * 4)
            (mEroView as FrameLayout).addView(
                errorImag,
                FrameLayout.LayoutParams(d, d, Gravity.CENTER)
            )
        } catch (e: IOException) {
            e.printStackTrace()
        }
        return mEroView
    }


    private fun createTableBar(): View {
        // tableBar布局
        val lTableBar = LinearLayout(mCx) // 屏宽0.14
        lTableBar.orientation = LinearLayout.HORIZONTAL
        // 向前，向后，刷新，关闭按钮；
        for (i in iconsName.indices) {
            val fl_btn = mCx?.let { FrameLayout(it) }
            fl_btn?.tag = iconsName[i]
            val selector: Drawable = DrawableUtils.createSelector(
                Color.rgb(0xF8, 0xF7, 0xF7), Color.rgb(0xE2, 0xE2, 0xE2)
            )
            fl_btn?.background = selector
            fl_btn?.setOnClickListener(this)
            fl_btn?.layoutParams = LinearLayout.LayoutParams(0, -1, 4f)
            lTableBar.addView(fl_btn)
            // add icon
            val v_icon = ImageView(mCx)
            val `is` = mCx?.assets?.open(
                String.format(
                    ICON_PATH,
                    iconsName[i]
                )
            )
            val background = Drawable.createFromStream(
                `is`,
                iconsName[i]
            )
            v_icon.background = background
            val d = (tableBar_h * 0.5).toInt()
            fl_btn?.addView(
                v_icon, FrameLayout.LayoutParams(
                    d, d,
                    Gravity.CENTER
                )
            )
            if (i != iconsName.size - 1) {
                val line = View(mCx)
                line.setBackgroundColor("#d5d4d4".toColorInt())
                val fParams: ViewGroup.LayoutParams = FrameLayout.LayoutParams(
                    1,
                    (tableBar_h * 0.8).toInt(), Gravity.END
                            or Gravity.CENTER_VERTICAL
                )
                fl_btn?.addView(line, fParams)
            }
        }
        return lTableBar
    }

    private fun createContentView(): View? {
        val layout = mCx?.let { FrameLayout(it) }
        mWebView = mCx?.let { WebView(it) }
        mWebView?.setInitialScale(0)


        initWebView(mCx, mWebView, object : WebViewClient() {
            private var errorCode = 0

            @SuppressLint("NewApi")
            override fun shouldOverrideUrlLoading(
                view: WebView?,
                request: WebResourceRequest?
            ): Boolean {
                val url = request?.url.toString()
                //支持拨打电话和发送短信
                if (url.startsWith("tel:")) {
                    val tel = Intent(Intent.ACTION_DIAL, url.toUri())
                    mCx?.startActivity(tel)
                    return true
                } else if (url.startsWith("smsto:") || url.startsWith("sms:")) {
                    val sms = Intent(Intent.ACTION_VIEW, url.toUri())
                    mCx?.startActivity(sms)
                    return true
                }
                if (url.startsWith("http://") || url.startsWith("https://")) {
                    try {
                        val hit = view?.hitTestResult
                        val hitType = hit?.type
                        if (hitType == HitTestResult.SRC_ANCHOR_TYPE) { // 点击超链接
                            LogUtils.d("shouldOverrideUrlLoading    超链     ：   $url")
                            view.loadUrl(url)
                            return true // 返回true浏览器执行默认的操作
                        } else if (hitType == 0) { // 重定向时hitType为0
                            LogUtils.d("shouldOverrideUrlLoading     302    ：   $url")
                            return false // 不捕获302重定向
                        } else {
                            return false
                        }
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                } else {
                    openDplink(mCx, url)
                    return true
                }
                return false
            }

            override fun onPageStarted(view: WebView?, url: String?, favicon: Bitmap?) {
                errorCode = 200
                if (pageStateListener != null) {
                    pageStateListener?.onWebStartLoad()
                }
            }

            override fun onPageFinished(view: WebView?, url: String?) {
                // LogUtils.d("onPageFinished     页面加载完成    ：   " + url);
                if (errorCode == 200) {
                    mEroView?.visibility = View.INVISIBLE
                }
                if (pageStateListener != null) {
                    pageStateListener?.onWebLoadFinish()
                }
            }

            @SuppressLint("NewApi")
            override fun onReceivedError(
                view: WebView?,
                request: WebResourceRequest?,
                error: WebResourceError?
            ) {
                errorCode = error?.errorCode?:0
                mEroView?.visibility = View.VISIBLE
            }

            @SuppressLint("WebViewClientOnReceivedSslError")
            override fun onReceivedSslError(
                view: WebView?,
                handler: SslErrorHandler?,
                error: SslError?
            ) {
                handler?.proceed()
            }
        }, object : WebChromeClient() {
            private var curProgress = 0
            override fun onProgressChanged(view: WebView?, newProgress: Int) {
                if (newProgress > 99) {
                    if (progressBar != null) {
                        progressBar?.visibility = View.INVISIBLE
                        progressBar?.progress = 0.also { curProgress = it }
                    }
                } else {
                    if (progressBar == null) {
                        progressBar =
                            ProgressBar(mCx, null, android.R.attr.progressBarStyleHorizontal)
                        // ClipDrawable drawable = new ClipDrawable(new ColorDrawable(Color.parseColor("#ff8800")), Gravity.START, ClipDrawable.HORIZONTAL);
                        // progressBar.setProgressDrawable(drawable);
                        webPage?.addView(
                            progressBar,
                            FrameLayout.LayoutParams(-1, tableBar_h / 15, Gravity.TOP)
                        )
                    } else if (newProgress - curProgress > 4) {
                        progressBar?.progress = newProgress.also { curProgress = it }
                        progressBar?.visibility = View.VISIBLE
                    }
                }
            }
        })


        //WebView设置下载监听
        mWebView?.setDownloadListener(object : DownloadListener {
            var appInfo: AppInfo? = null

            override fun onDownloadStart(
                url: String, userAgent: String,
                contentDisposition: String, mimetype: String,
                contentLength: Long
            ) {
                if (TextUtils.isEmpty(url) || contentLength <= 0) {
                    return
                }

                if (dUrls?.contains(url) == true) {
//                    Utils.showToastSafe("正在下载...");
                    return
                }

                if (appInfo != null && url == appInfo?.downloadUrl) {
                    val packageName = appInfo?.packageName
                    if (DownLoadManager.getInstance(mCx).isAppInstalled(packageName)) { //检测是否已经安装
                        if (DownLoadManager.getInstance(mCx).openApp(packageName, -1)) {
//                            LogUtils.d("WebView 打开 已安装 app--->" + packageName);
                        }
                    } else {
                        dUrls?.add(url)
                        DownLoadManager.getInstance(mCx)
                            .downloadWithShow(createDownloadItem(url), mAd)
                    }
                } else {
                    dUrls?.add(url)
                    DownLoadManager.getInstance(mCx).downloadWithShow(createDownloadItem(url), mAd)
                    appInfo = AppInfo(url, contentLength)
                }
            }
        })
        layout?.addView(mWebView, FrameLayout.LayoutParams(-1, -1))
        return layout
    }


    private fun createDownloadItem(url: String): DownloadItem {
        val item = DownloadItem()
        item.name = KeyUtil.getMD5(url) //设置下载项目名称
        item.downLoadUrl = url.trim { it <= ' ' } //下载地址
        item.listener = object : DownloadStateListener {
            override fun onDownloadError(
                item: DownloadItem?,
                errorCode: Int,
                errorMsg: String?
            ) {
                dUrls?.remove(url)
//                LogUtils.d("广告下载错误==onDownloadError==$errorMsg::errorCode:$errorCode")
            }

            override fun onDownloadStart(item: DownloadItem?, adInfo: AdBean?) {
            }

            override fun onDownloaded(item: DownloadItem?, adInfo: AdBean?) {
                dUrls?.remove(url)
            }

            override fun onInstalled(item: DownloadItem?, adInfo: AdBean?) {
            }

            override fun onOpened(item: DownloadItem?, adInfo: AdBean?) {
            }
        }

        return item
    }

    fun loadUrl(url: String) {
        if (mWebView != null && !TextUtils.isEmpty(url)) {
            mWebView?.clearHistory()
            mWebView?.loadUrl(url)
        }
    }

    override fun onClick(v: View) {
        val vTag = v.tag as String
        if (iconsName[0] == vTag) { // 后退
            goBack()
        } else if (iconsName[1] == vTag) { // 向前
            goForward()
        } else if (iconsName[2] == vTag || ERO_IMAGE == vTag) { // 刷新
            reload()
        } else if (iconsName[3] == vTag) { // 关闭
            if (pageStateListener != null) {
                pageStateListener?.onCloseBtnClick()
            }
        }
    }

    private fun reload() {
        if (mWebView != null) {
            mWebView?.reload()
        }
    }

    private fun goForward(): Boolean {
        if (mWebView != null && mWebView?.canGoForward() == true) {
            mWebView?.goForward()
            return true
        }
        return false
    }

    private fun goBack(): Boolean {
        if (mWebView != null && mWebView?.canGoBack() == true) {
            mWebView?.goBack()
            return true
        }
        return false
    }

    //    void onResume() {
    //        if (mWebView != null) {
    //            mWebView.resumeTimers();
    //            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
    //                mWebView.onResume();
    //            }
    //        }
    //    }
    //
    //    void onPause() {
    //        if (mWebView != null) {
    //            mWebView.pauseTimers();
    //            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB) {
    //                mWebView.onPause();
    //            }
    //            mWebView.clearCache(true);
    //        }
    //    }

    //
    //    private void reportDownloadState(int dState, String pk) {
    //        if (pageStateListener != null) {
    //            pageStateListener.onDownLoadChange(dState, pk);
    //        }
    //    }


    interface BrowserPageStateListener {
        fun onWebStartLoad()

        fun onWebLoadFinish()

        fun onCloseBtnClick()
    }

    private fun openDplink(context: Context?, deepLink: String) {
        try {
            val deepLinkIntent = Intent.parseUri(deepLink, Intent.URI_INTENT_SCHEME)
            deepLinkIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            val resolveInfo = context?.packageManager?.resolveActivity(
                deepLinkIntent,
                PackageManager.MATCH_DEFAULT_ONLY
            )
            if (resolveInfo != null) {
                context.startActivity(deepLinkIntent)
            }
        } catch (e: ActivityNotFoundException) {
            // LogUtils.d("DeepLink NotFound:"+deepLink);
        } catch (e: URISyntaxException) {
            e.printStackTrace()
            //LogUtils.d("DeepLink NotFound:"+deepLink);
        }
    }

    companion object {
        private val iconsName = arrayOf("back", "forward", "refesh", "close")
        private const val ERO_IMAGE = "hj_error"

        private const val ICON_PATH = SDKInfo.ADTAG + "/%s.png"

        @SuppressLint("SetJavaScriptEnabled")
        @Suppress("deprecation")
        private fun initWebView(
            context: Context?,
            wView: WebView?,
            webClient: WebViewClient?,
            chromeClient: WebChromeClient?
        ) {
            val webSettings = wView?.settings
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                webSettings?.mixedContentMode = WebSettings.MIXED_CONTENT_ALWAYS_ALLOW
            }

            webSettings?.setSupportZoom(true)
            webSettings?.javaScriptEnabled = true
            webSettings?.javaScriptCanOpenWindowsAutomatically = true
            //        webSettings.setBuiltInZoomControls(true);// support zoom
            webSettings?.useWideViewPort = true // 这个很关键
            webSettings?.loadWithOverviewMode = true
            webSettings?.blockNetworkImage = false
            WebView.setWebContentsDebuggingEnabled(true)

            webSettings?.domStorageEnabled = true
            webSettings?.setAppCacheMaxSize((1024 * 1024 * 5).toLong())
            val appCachePath = context?.cacheDir?.absolutePath
            webSettings?.setAppCachePath(appCachePath)
            webSettings?.allowFileAccess = true
            webSettings?.setAppCacheEnabled(true)

            val metrics = DisplayMetrics()
            val wManager = wView?.context
               ?.getSystemService(Context.WINDOW_SERVICE) as WindowManager
            wManager.defaultDisplay.getMetrics(metrics)
            val mDensity = metrics.densityDpi
            if (mDensity == 240) {
                webSettings?.defaultZoom = ZoomDensity.FAR
            } else if (mDensity == 160) {
                webSettings?.defaultZoom = ZoomDensity.MEDIUM
            } else if (mDensity == 120) {
                webSettings?.defaultZoom = ZoomDensity.CLOSE
            } else if (mDensity == DisplayMetrics.DENSITY_XHIGH) {
                webSettings?.defaultZoom = ZoomDensity.FAR
            } else if (mDensity == DisplayMetrics.DENSITY_TV) {
                webSettings?.defaultZoom = ZoomDensity.FAR
            }
            if (webClient != null) {
                wView.webViewClient = webClient
            }
            if (chromeClient != null) {
                wView.webChromeClient = chromeClient
            }
            // 取消滚动条
            wView.isHorizontalScrollBarEnabled = false //水平不显示
            wView.isVerticalScrollBarEnabled = false //垂直不显示
        }
    }

    fun destroy() {
        if (pageStateListener != null) {
            pageStateListener?.onCloseBtnClick()
        }
        if (mWebView != null) {
            mWebView?.destroy()
        }
    }
}
