package com.halomobi.ssp.bussiness.module_sdk.view.web

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.util.Log
import android.view.KeyEvent
import android.view.View
import android.view.ViewGroup
import android.view.Window
import android.widget.FrameLayout
import com.halomobi.ssp.base.common.ConstantPool.TrackerType
import com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager
import com.halomobi.ssp.bussiness.module_sdk.view.web.BrowserPagNative.BrowserPageStateListener
import com.halomobi.ssp.framework.controller.AdController
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener
import com.halomobi.ssp.model.request.bean.AdBean
import com.ssp.sdk.R

class BrowserView : Activity(), BrowserPageStateListener, View.OnAttachStateChangeListener {
    private var pagNative: BrowserPagNative? = null
    private var mAd: AdBean? = null
    private var frameLayout: FrameLayout? = null
    private var listener: ClickAdStateChangListener? = null
    private var click_url: String? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        init()
    }

    private fun init() {
        try {
            requestWindowFeature(Window.FEATURE_NO_TITLE);
            setContentView(R.layout.hj_browser_view)
            frameLayout = findViewById(R.id.browser_view)
            click_url = intent.getStringExtra("click_url").toString()
            this.mAd = AdController.getInstance(this)?.adBean
            pagNative = BrowserPagNative(this, this, mAd)
            this.listener = AdController.getInstance(this)?.clickListener
            frameLayout?.addOnAttachStateChangeListener(this)
            load(click_url)
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }


    fun load(click_url: String?) {
        if (pagNative?.webPage == null) {
            return
        }
        frameLayout?.removeAllViews()
        frameLayout?.addView(
            pagNative?.webPage, ViewGroup.LayoutParams(
                ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT
            )
        )
        if (click_url != null) {
            pagNative?.loadUrl(click_url)
        }
    }


    override fun onWebStartLoad() {
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_START_LOAD)
        }
        if (mAd?.isSubmitClkTrk != true) {
            mAd?.isSubmitClkTrk = true
            mAd?.getTracks(TrackerType.CLICK)
                ?.let { ReportTrackerManager.instance?.reportTrack(it) } //点击监播
        }
    }

    override fun onWebLoadFinish() {
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_LOAD_FINISH)
        }
        if (mAd?.ctop == 2L && mAd?.isSubmitClkTrk != true) { //页面加载完毕之后发送点击监播
            mAd?.isSubmitClkTrk = true
            mAd?.getTracks(TrackerType.CLICK)
                ?.let { ReportTrackerManager.instance?.reportTrack(it) } //点击监播
        }
    }

    override fun onCloseBtnClick() {
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_CLOSE)
        }
        finish()
    }


    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        if (keyCode == KeyEvent.KEYCODE_BACK || keyCode == KeyEvent.KEYCODE_HOME) {
            return true
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onViewAttachedToWindow(p0: View?) {
        // 视图被添加到窗口时调用
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_OPEN)
        }
    }

    override fun onViewDetachedFromWindow(p0: View?) {
        // 视图从窗口移除时调用
    }

    override fun onDestroy() {
        super.onDestroy()
        if (pagNative != null) {
            pagNative?.destroy()
            pagNative = null
        }

    }
}
