package com.halomobi.ssp.bussiness.module_sdk.view.web

import android.content.Context
import android.view.WindowManager
import com.halomobi.ssp.model.request.bean.AdBean

import android.app.Activity
import android.app.AlertDialog

import android.content.DialogInterface
import android.content.DialogInterface.OnDismissListener
import android.content.DialogInterface.OnKeyListener
import android.content.DialogInterface.OnShowListener

import android.view.KeyEvent
import android.view.ViewGroup.LayoutParams
import android.view.Window
import com.halomobi.ssp.base.common.ConstantPool.TrackerType.Companion.CLICK
import com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener.Companion.STATE_WEB_LOAD_FINISH
import com.halomobi.ssp.framework.listener.ClickAdStateChangListener.Companion.STATE_WEB_START_LOAD

class BrowserViewPrompt(private val mCx: Context, private val mAd: AdBean?) :
    BrowserPagNativePrompt.BrowserPageStateListener,
    OnKeyListener, OnDismissListener, OnShowListener {
    private var dialog: AlertDialog? = null
    private var pagNative: BrowserPagNativePrompt? = null


    private var listener: ClickAdStateChangListener? = null


    init {
        init()
    }

    private fun init() {
        try {
            pagNative = BrowserPagNativePrompt(mCx, this, mAd)
            dialog = AlertDialog.Builder(mCx).create()
            dialog?.setOnKeyListener(this)
            dialog?.setOnShowListener(this)
            dialog?.setOnDismissListener(this)
            dialog?.requestWindowFeature(Window.FEATURE_NO_TITLE)
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    fun load(click_url: String, isSys: Boolean) {
        if (mCx is Activity && mCx.isFinishing()) {
            return
        }

        if (dialog != null && dialog?.isShowing != true && !(mCx as Activity).isFinishing()) {
            val window: Window = dialog?.window
                ?: //                LogUtils.d("window == null");
                return

            if (isSys) {
                window.setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT)
            }
            dialog?.show()
            val lp: WindowManager.LayoutParams = window.getAttributes()
            lp.width = -1
            lp.height = -1
            window.setAttributes(lp)
            if (pagNative?.getWebPage() == null) {
                return
            }
            pagNative?.getWebPage()?.let { dialog?.setContentView(it, LayoutParams(-1, -1)) }
            //清除flags,获取焦点
            dialog?.window
                ?.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE or WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
            //弹出输入法
            dialog?.getWindow()
                ?.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_VISIBLE)

            pagNative?.loadUrl(click_url)
        }
    }

    fun setWebPagListener(listener: ClickAdStateChangListener?) {
        this.listener = listener
    }

    override fun onShow(dialog: DialogInterface?) {
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_OPEN)
        }
    }

    override fun onWebStartLoad() {
        if (listener != null) {
            listener?.onClickAdStateChang(STATE_WEB_START_LOAD)
        }
        if (mAd?.isSubmitClkTrk != true) {
//            LogUtils.d("web 页开始加载   页面开始加载发送点击监播");
            mAd?.isSubmitClkTrk = true
            ReportTrackerManager.instance?.reportTrack(mAd?.getTracks(CLICK)) //点击监播
        }
    }

    override fun onWebLoadFinish() {
        if (listener != null) {
            listener?.onClickAdStateChang(STATE_WEB_LOAD_FINISH)
        }
        if (mAd?.ctop?.toInt() == 2 && !mAd.isSubmitClkTrk) { //页面加载完毕之后发送点击监播
//            LogUtils.d("web 页加载完毕   页面加载完毕之后发送点击监播");
            mAd.isSubmitClkTrk = true
            ReportTrackerManager.instance?.reportTrack(mAd.getTracks(CLICK)) //点击监播
        }
    }

    override fun onCloseBtnClick() {
        if (dialog != null && dialog?.isShowing() == true) {
            dialog?.dismiss()
        }
    }

    override fun onDismiss(dialog: DialogInterface?) {
        if (listener != null) {
            listener?.onClickAdStateChang(ClickAdStateChangListener.STATE_WEB_CLOSE)
        }
        pagNative?.destroy()
    }

    override fun onKey(dialog: DialogInterface?, keyCode: Int, event: KeyEvent): Boolean {
        return keyCode == KeyEvent.KEYCODE_BACK && event.getAction() === KeyEvent.ACTION_UP && pagNative?.goBack() == true
    }
}