package com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd

import android.content.Context
import android.content.pm.ActivityInfo
import android.media.AudioManager
import android.media.AudioManager.OnAudioFocusChangeListener
import android.media.MediaPlayer
import android.provider.Settings
import android.provider.Settings.SettingNotFoundException
import android.util.AttributeSet
import android.util.Log
import android.view.Gravity
import android.view.ViewGroup
import android.view.WindowManager
import android.widget.FrameLayout
import android.widget.SeekBar
import android.widget.SeekBar.OnSeekBarChangeListener
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.getSavedProgress
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.getScreenWidth
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.getStatusBarHeight
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.getWindow
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.hideStatusBar
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.hideSystemUI
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.saveProgress
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.scanForActivity
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.setRequestedOrientation
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.showStatusBar
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.showSystemUI
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.stringForTime
import com.ssp.sdk.R
import java.lang.reflect.Constructor
import java.lang.reflect.InvocationTargetException
import java.util.LinkedList
import java.util.Locale
import kotlin.math.abs


abstract class Jzvd : FrameLayout, OnSeekBarChangeListener {
    @JvmField
    var state: Int = -1

    @JvmField
    var screen: Int = -1

    @JvmField
    var jzDataSource: JZDataSource? = null
    var widthRatio: Int = 0
    var heightRatio: Int = 0
    var mediaInterfaceClass: Class<*>? = null

    @JvmField
    var mediaInterface: JZMediaInterface? = null

    //    public int positionInList = -1;//很想干掉它
    var videoRotation: Int = 0
    var seekToManulPosition: Int = -1
    var seekToInAdvance: Long = 0

    //    public ImageView startButton;
    //    public SeekBar progressBar;
    //    public ImageView fullscreenButton;
    //    public TextView currentTimeTextView, totalTimeTextView;
    var textureViewContainer: ViewGroup? = null

    //    public ViewGroup topContainer, bottomContainer;
    var textureView: JZTextureView? = null
    var preloading: Boolean = false

    @JvmField
    protected var gobakFullscreenTime: Long = 0 //这个应该重写一下，刷新列表，新增列表的刷新，不打断播放，应该是个flag

    @JvmField
    protected var gotoFullscreenTime: Long = 0

    //    protected Timer UPDATE_PROGRESS_TIMER;
    protected var mScreenWidth: Int = 0
    protected var mScreenHeight: Int = 0
    protected var mAudioManager: AudioManager? = null

    //    protected Jzvd.ProgressTimerTask mProgressTimerTask;
    protected var mTouchingProgressBar: Boolean = false
    protected var mDownX: Float = 0f
    protected var mDownY: Float = 0f
    protected var mChangeVolume: Boolean = false
    protected var mChangePosition: Boolean = false
    protected var mChangeBrightness: Boolean = false
    protected var mGestureDownPosition: Long = 0
    protected var mGestureDownVolume: Int? = 0
    protected var mGestureDownBrightness: Float = 0f
    protected var mSeekTimePosition: Long = 0

    @JvmField
    protected var jzvdContext: Context? = null
    protected var mCurrentPosition: Long = 0

    /**
     * 如果不在列表中可以不加block
     */
    protected var blockLayoutParams: ViewGroup.LayoutParams? = null
    protected var blockIndex: Int = 0
    protected var blockWidth: Int = 0
    protected var blockHeight: Int = 0

    var mWidth: Int = 0
    var mHeight: Int = 0 //广告的实际宽高

    constructor(context: Context) : super(context) {
        init(context)
    }

    constructor(context: Context, width: Int, height: Int) : super(context) {
        mWidth = width
        mHeight = height
        init(context)
    }

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs) {
        init(context)
    }

    //    public static void setTextureViewRotation(int rotation) {
    //        if (CURRENT_JZVD != null && CURRENT_JZVD.textureView != null) {
    //            CURRENT_JZVD.textureView.setRotation(rotation);
    //        }
    //    }
    //
    //    public static void setVideoImageDisplayType(int type) {
    //        Jzvd.VIDEO_IMAGE_DISPLAY_TYPE = type;
    //        if (CURRENT_JZVD != null && CURRENT_JZVD.textureView != null) {
    //            CURRENT_JZVD.textureView.requestLayout();
    //        }
    //    }
    abstract val layoutId: Int
        //    public static void setTextureViewRotation(int rotation) {
//        get

    //    public static void setTextureViewRotation(int rotation) {
    //        if (CURRENT_JZVD != null && CURRENT_JZVD.textureView != null) {
    //            CURRENT_JZVD.textureView.setRotation(rotation);
    //        }
    //    }
    //
    //    public static void setVideoImageDisplayType(int type) {
    //        Jzvd.VIDEO_IMAGE_DISPLAY_TYPE = type;
    //        if (CURRENT_JZVD != null && CURRENT_JZVD.textureView != null) {
    //            CURRENT_JZVD.textureView.requestLayout();
    //        }
    //    }
//    abstract fun getLayoutId(): Int

    open fun init(context: Context) {
        inflate(context, layoutId, this)
        jzvdContext = context
        //        startButton = findViewById(R.id.start);
//        fullscreenButton = findViewById(R.id.fullscreen);
//        progressBar = findViewById(R.id.bottom_seek_progress);
//        currentTimeTextView = findViewById(R.id.current);
//        totalTimeTextView = findViewById(R.id.total);
//        bottomContainer = findViewById(R.id.layout_bottom);
        textureViewContainer = findViewById(R.id.surface_container)

        //        topContainer = findViewById(R.id.layout_top);

//        if (startButton == null) {
//            startButton = new ImageView(context);
//        }
//        if (fullscreenButton == null) {
//            fullscreenButton = new ImageView(context);
//        }
//        if (progressBar == null) {
//            progressBar = new SeekBar(context);
//        }
//        if (currentTimeTextView == null) {
//            currentTimeTextView = new TextView(context);
//        }
//        if (totalTimeTextView == null) {
//            totalTimeTextView = new TextView(context);
//        }
//        if (bottomContainer == null) {
//            bottomContainer = new LinearLayout(context);
//        }
        if (textureViewContainer == null) {
            textureViewContainer = FrameLayout(context)
        }

        //        if (topContainer == null) {
//            topContainer = new RelativeLayout(context);
//        }

//        startButton.setOnClickListener(this);
//        fullscreenButton.setOnClickListener(this);
//        progressBar.setOnSeekBarChangeListener(this);
//        bottomContainer.setOnClickListener(this);
//        textureViewContainer.setOnClickListener(this);
//        textureViewContainer.setOnTouchListener(this);
        mScreenWidth = getContext().resources.displayMetrics.widthPixels
        mScreenHeight = getContext().resources.displayMetrics.heightPixels

        state = STATE_IDLE
    }

    fun setUp(url: String?, title: String?) {
        setUp(JZDataSource(url, title), SCREEN_NORMAL)
    }

    fun setUp(url: String?, title: String?, screen: Int) {
        setUp(JZDataSource(url, title), screen)
    }

    fun setUp(jzDataSource: JZDataSource?, screen: Int) {
        setUp(jzDataSource, screen, JZMediaSystem::class.java)
    }

    fun setUp(url: String?, title: String?, screen: Int, mediaInterfaceClass: Class<*>?) {
        setUp(JZDataSource(url, title), screen, mediaInterfaceClass)
    }

    open fun setUp(jzDataSource: JZDataSource?, screen: Int, mediaInterfaceClass: Class<*>?) {
        this.jzDataSource = jzDataSource
        this.screen = screen
        onStateNormal()
        this.mediaInterfaceClass = mediaInterfaceClass
    }

    //    public void setMediaInterface(Class mediaInterfaceClass) {
    //        reset();
    //        this.mediaInterfaceClass = mediaInterfaceClass;
    //    }
    //    @Override
    //    public void onClick(View v) {
    //        int i = v.getId();
    //        if (i == R.id.start) {
    //            clickStart();
    //        } else if (i == R.id.fullscreen) {
    //            clickFullscreen();
    //        }
    //    }
    //    protected void clickFullscreen() {
    //        Log.i(TAG, "onClick fullscreen [" + this.hashCode() + "] ");
    //        if (state == STATE_AUTO_COMPLETE) return;
    //        if (screen == SCREEN_FULLSCREEN) {
    //            //quit fullscreen
    //            backPress();
    //        } else {
    //            Log.d(TAG, "toFullscreenActivity [" + this.hashCode() + "] ");
    //            gotoFullscreen();
    //        }
    //    }
    //    protected void clickStart() {
    //        Log.i(TAG, "onClick start [" + this.hashCode() + "] ");
    //        if (jzDataSource == null || jzDataSource.urlsMap.isEmpty() || jzDataSource.getCurrentUrl() == null) {
    //            Toast.makeText(getContext(), getResources().getString(R.string.no_url), Toast.LENGTH_SHORT).show();
    //            return;
    //        }
    //        if (state == STATE_NORMAL) {
    //            if (!jzDataSource.getCurrentUrl().toString().startsWith("file") && !
    //                    jzDataSource.getCurrentUrl().toString().startsWith("/") &&
    //                    !JZUtils.isWifiConnected(getContext()) && !WIFI_TIP_DIALOG_SHOWED) {//这个可以放到std中
    //                showWifiDialog();
    //                return;
    //            }
    //            startVideo();
    //        } else if (state == STATE_PLAYING) {
    //            Log.d(TAG, "pauseVideo [" + this.hashCode() + "] ");
    //            mediaInterface.pause();
    //            onStatePause();
    //        } else if (state == STATE_PAUSE) {
    //            mediaInterface.start();
    //            onStatePlaying();
    //        } else if (state == STATE_AUTO_COMPLETE) {
    //            startVideo();
    //        }
    //    }
    //    @Override
    //    public boolean onTouch(View v, MotionEvent event) {
    //        float x = event.getX();
    //        float y = event.getY();
    //        int id = v.getId();
    //        if (id == R.id.surface_container) {
    //            switch (event.getAction()) {
    //                case MotionEvent.ACTION_DOWN:
    //                    touchActionDown(x, y);
    //                    break;
    //                case MotionEvent.ACTION_MOVE:
    //                    touchActionMove(x, y);
    //                    break;
    //                case MotionEvent.ACTION_UP:
    //                    touchActionUp();
    //                    break;
    //            }
    //        }
    //        return false;
    //    }
    protected fun touchActionUp() {
        Log.i(TAG, "onTouch surfaceContainer actionUp [" + this.hashCode() + "] ")
        mTouchingProgressBar = false
        dismissProgressDialog()
        dismissVolumeDialog()
        dismissBrightnessDialog()
        if (mChangePosition) {
            mediaInterface?.seekTo(mSeekTimePosition)
            val duration = getDuration()
            val progress = (mSeekTimePosition * 100 / (if (duration == 0L) 1 else duration)).toInt()
            //            progressBar.setProgress(progress);
        }
        if (mChangeVolume) {
            //change volume event
        }
        //        startProgressTimer();
    }

    protected fun touchActionMove(x: Float, y: Float) {
        Log.i(TAG, "onTouch surfaceContainer actionMove [" + this.hashCode() + "] ")
        val deltaX = x - mDownX
        var deltaY = y - mDownY
        val absDeltaX = abs(deltaX.toDouble()).toFloat()
        val absDeltaY = abs(deltaY.toDouble()).toFloat()
        if (screen == SCREEN_FULLSCREEN) {
            //拖动的是NavigationBar和状态栏
            if (mDownX > getScreenWidth(
                    context
                ) || mDownY < getStatusBarHeight(
                    context
                )
            ) {
                return
            }
            if (!mChangePosition && !mChangeVolume && !mChangeBrightness) {
                if (absDeltaX > THRESHOLD || absDeltaY > THRESHOLD) {
//                    cancelProgressTimer();
                    if (absDeltaX >= THRESHOLD) {
                        // 全屏模式下的CURRENT_STATE_ERROR状态下,不响应进度拖动事件.
                        // 否则会因为mediaplayer的状态非法导致App Crash
                        if (state != STATE_ERROR) {
                            mChangePosition = true
                            mGestureDownPosition = getCurrentPositionWhenPlaying()
                        }
                    } else {
                        //如果y轴滑动距离超过设置的处理范围，那么进行滑动事件处理
                        if (mDownX < mScreenHeight * 0.5f) { //左侧改变亮度
                            mChangeBrightness = true
                            val lp = getWindow(
                                context
                            )?.attributes
                            if ((lp?.screenBrightness ?: -1.0f) < 0) {
                                try {
                                    mGestureDownBrightness = Settings.System.getInt(
                                        context.contentResolver, Settings.System.SCREEN_BRIGHTNESS
                                    ).toFloat()
                                    Log.i(
                                        TAG,
                                        "current system brightness: $mGestureDownBrightness"
                                    )
                                } catch (e: SettingNotFoundException) {
                                    e.printStackTrace()
                                }
                            } else {
                                mGestureDownBrightness = (lp?.screenBrightness ?: -1.0f) * 255
                                Log.i(
                                    TAG,
                                    "current activity brightness: $mGestureDownBrightness"
                                )
                            }
                        } else { //右侧改变声音
                            mChangeVolume = true
                            mGestureDownVolume =
                                mAudioManager?.getStreamVolume(AudioManager.STREAM_MUSIC)
                        }
                    }
                }
            }
        }
        if (mChangePosition) {
            val totalTimeDuration = getDuration()
            if (PROGRESS_DRAG_RATE <= 0) {
                Log.d(TAG, "error PROGRESS_DRAG_RATE value")
                PROGRESS_DRAG_RATE = 1f
            }
            mSeekTimePosition =
                (mGestureDownPosition + deltaX * totalTimeDuration / (mScreenWidth * PROGRESS_DRAG_RATE)).toInt()
                    .toLong()
            if (mSeekTimePosition > totalTimeDuration) mSeekTimePosition = totalTimeDuration
            val seekTime = stringForTime(mSeekTimePosition)
            val totalTime = stringForTime(totalTimeDuration)

            showProgressDialog(deltaX, seekTime, mSeekTimePosition, totalTime, totalTimeDuration)
        }
        if (mChangeVolume) {
            deltaY = -deltaY
            val max = mAudioManager?.getStreamMaxVolume(AudioManager.STREAM_MUSIC)
            val deltaV = (max?.times(deltaY)?.times(3)?.div(mScreenHeight))?.toInt()
            deltaV?.let {
                mGestureDownVolume?.plus(it)?.let {
                    mAudioManager?.setStreamVolume(
                        AudioManager.STREAM_MUSIC,
                        it,
                        0
                    )
                }
            }
            //dialog中显示百分比
            val volumePercent =
                (max?.let { mGestureDownVolume?.times(100) ?.div(it) ?.plus(deltaY * 3 * 100 / mScreenHeight) })?.toInt()
            volumePercent?.let { showVolumeDialog(-deltaY, it) }
        }

        if (mChangeBrightness) {
            deltaY = -deltaY
            val deltaV = (255 * deltaY * 3 / mScreenHeight).toInt()
            val params = getWindow(
                context
            )?.attributes
            if (((mGestureDownBrightness + deltaV) / 255) >= 1) { //这和声音有区别，必须自己过滤一下负值
                params?.screenBrightness = 1f
            } else if (((mGestureDownBrightness + deltaV) / 255) <= 0) {
                params?.screenBrightness = 0.01f
            } else {
                params?.screenBrightness = (mGestureDownBrightness + deltaV) / 255
            }
            getWindow(context)?.attributes =
                params
            //dialog中显示百分比
            val brightnessPercent =
                (mGestureDownBrightness * 100 / 255 + deltaY * 3 * 100 / mScreenHeight).toInt()
            showBrightnessDialog(brightnessPercent)
            //                        mDownY = y;
        }
    }

    protected fun touchActionDown(x: Float, y: Float) {
        Log.i(TAG, "onTouch surfaceContainer actionDown [" + this.hashCode() + "] ")
        mTouchingProgressBar = true

        mDownX = x
        mDownY = y
        mChangeVolume = false
        mChangePosition = false
        mChangeBrightness = false
    }

    open fun onStateNormal() {
        Log.i(TAG, "onStateNormal " + " [" + this.hashCode() + "] ")
        state = STATE_NORMAL
        //        cancelProgressTimer();
        if (mediaInterface != null) mediaInterface?.release()
    }

    open fun onStatePreparing() {
        Log.i(TAG, "onStatePreparing " + " [" + this.hashCode() + "] ")
        state = STATE_PREPARING
    }

    open fun onStatePreparingPlaying() {
        Log.i(TAG, "onStatePreparingPlaying " + " [" + this.hashCode() + "] ")
        state = STATE_PREPARING_PLAYING
    }

    open fun onStatePreparingChangeUrl() {
        Log.i(TAG, "onStatePreparingChangeUrl " + " [" + this.hashCode() + "] ")
        state = STATE_PREPARING_CHANGE_URL

        //        releaseAllVideos();
//        startVideo();

//        mediaInterface.prepare();
    }

    open fun changeUrl(jzDataSource: JZDataSource?, seekToInAdvance: Long) {
        this.jzDataSource = jzDataSource
        this.seekToInAdvance = seekToInAdvance
        onStatePreparingChangeUrl()
    }

    fun onPrepared() {
        Log.i(TAG, "onPrepared " + " [" + this.hashCode() + "] ")
        state = STATE_PREPARED
        if (!preloading) {
            mediaInterface?.start() //这里原来是非线程
            preloading = false
        }
        if (jzDataSource?.currentUrl.toString().lowercase(Locale.getDefault()).contains("mp3") ||
            jzDataSource?.currentUrl.toString().lowercase(Locale.getDefault()).contains("wma") ||
            jzDataSource?.currentUrl.toString().lowercase(Locale.getDefault()).contains("aac") ||
            jzDataSource?.currentUrl.toString().lowercase(Locale.getDefault()).contains("m4a") ||
            jzDataSource?.currentUrl.toString().lowercase(Locale.getDefault()).contains("wav")
        ) {
            onStatePlaying()
        }
    }

    fun startPreloading() {
        preloading = true
        startVideo()
    }

    //    /**
    //     * 如果STATE_PREPARED就播放，如果没准备完成就走正常的播放函数startVideo();
    //     */
    //    public void startVideoAfterPreloading() {
    //        if (state == STATE_PREPARED) {
    //            mediaInterface.start();
    //        } else {
    //            preloading = false;
    //            startVideo();
    //        }
    //    }
    open fun onStatePlaying() {
        Log.i(TAG, "onStatePlaying " + " [" + this.hashCode() + "] ")
        if (state == STATE_PREPARED) { //如果是准备完成视频后第一次播放，先判断是否需要跳转进度。
            Log.d(TAG, "onStatePlaying:STATE_PREPARED ")
            mAudioManager =
                getApplicationContext()?.getSystemService(Context.AUDIO_SERVICE) as AudioManager
            mAudioManager?.requestAudioFocus(
                onAudioFocusChangeListener,
                AudioManager.STREAM_MUSIC,
                AudioManager.AUDIOFOCUS_GAIN_TRANSIENT
            )
            if (seekToInAdvance != 0L) {
                mediaInterface?.seekTo(seekToInAdvance)
                seekToInAdvance = 0
            } else {
                val position = jzDataSource?.currentUrl?.let {
                    getSavedProgress(
                        context, it
                    )
                }
                if (position != 0L) {
                    position?.let { mediaInterface?.seekTo(it) } //这里为什么区分开呢，第一次的播放和resume播放是不一样的。 这里怎么区分是一个问题。然后
                }
            }
        }
        state = STATE_PLAYING
        //        startProgressTimer();
    }

    open fun onStatePause() {
        Log.i(TAG, "onStatePause " + " [" + this.hashCode() + "] ")
        state = STATE_PAUSE
        //        startProgressTimer();
    }

    open fun onStateError() {
        Log.i(TAG, "onStateError " + " [" + this.hashCode() + "] ")
        state = STATE_ERROR
        //        cancelProgressTimer();
    }

    open fun onStateAutoComplete() {
        Log.i(TAG, "onStateAutoComplete " + " [" + this.hashCode() + "] ")
        state = STATE_AUTO_COMPLETE
        //        cancelProgressTimer();
//        progressBar.setProgress(100);
//        currentTimeTextView.setText(totalTimeTextView.getText());
    }

    fun onInfo(what: Int, extra: Int) {
        Log.d(
            TAG,
            "onInfo what - $what extra - $extra"
        )
        if (what == MediaPlayer.MEDIA_INFO_VIDEO_RENDERING_START) {
            Log.d(TAG, "MEDIA_INFO_VIDEO_RENDERING_START")
            if (state == STATE_PREPARED || state == STATE_PREPARING_CHANGE_URL || state == STATE_PREPARING_PLAYING) {
                onStatePlaying() //开始渲染图像，真正进入playing状态
            }
        } else if (what == MediaPlayer.MEDIA_INFO_BUFFERING_START) {
            Log.d(TAG, "MEDIA_INFO_BUFFERING_START")
            backUpBufferState = state
            setState(STATE_PREPARING_PLAYING)
        } else if (what == MediaPlayer.MEDIA_INFO_BUFFERING_END) {
            Log.d(TAG, "MEDIA_INFO_BUFFERING_END")
            if (backUpBufferState != -1) {
                setState(backUpBufferState)
                backUpBufferState = -1
            }
        }
    }

    fun onError(what: Int, extra: Int) {
        Log.e(TAG, "onError " + what + " - " + extra + " [" + this.hashCode() + "] ")
        if (what != 38 && extra != -38 && what != -38 && extra != 38 && extra != -19) {
            onStateError()
            mediaInterface?.release()
        }
    }

    open fun onCompletion() {
        Runtime.getRuntime().gc()
        Log.i(TAG, "onAutoCompletion " + " [" + this.hashCode() + "] ")
        //        cancelProgressTimer();
        dismissBrightnessDialog()
        dismissProgressDialog()
        dismissVolumeDialog()
        onStateAutoComplete()
        mediaInterface?.release()
        scanForActivity(context)?.window?.clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)
        jzDataSource?.currentUrl?.let { saveProgress(context, it, 0) }

        if (screen == SCREEN_FULLSCREEN) {
            if (CONTAINER_LIST.isEmpty()) {
                clearFloatScreen() //直接进入全屏
            } else {
                gotoNormalCompletion()
            }
        }
    }

    fun gotoNormalCompletion() {
        gobakFullscreenTime = System.currentTimeMillis() //退出全屏
        val vg = (scanForActivity(jzvdContext))?.window?.decorView as ViewGroup
        vg.removeView(this)
        textureViewContainer?.removeView(textureView)
        CONTAINER_LIST.last.removeViewAt(blockIndex) //remove block
        CONTAINER_LIST.last.addView(
            this, blockIndex, blockLayoutParams
        )
        CONTAINER_LIST.pop()
        setScreenNormal()
        showStatusBar(jzvdContext)
        setRequestedOrientation(jzvdContext, NORMAL_ORIENTATION)
        showSystemUI(jzvdContext)
    }

    /**
     * 多数表现为中断当前播放
     */
    open fun reset() {
        Log.i(TAG, "reset " + " [" + this.hashCode() + "] ")
        //        if (state == STATE_PLAYING || state == STATE_PAUSE) {
//            long position = getCurrentPositionWhenPlaying();
//          JZUtils.saveProgress(getContext(), jzDataSource.getCurrentUrl(), position);
//        }
//        cancelProgressTimer();
        dismissBrightnessDialog()
        dismissProgressDialog()
        dismissVolumeDialog()
        onStateNormal()
        textureViewContainer?.removeAllViews()

        val mAudioManager =
            getApplicationContext()?.getSystemService(Context.AUDIO_SERVICE) as AudioManager
        mAudioManager.abandonAudioFocus(onAudioFocusChangeListener)
        scanForActivity(context)?.window?.clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)
        if (mediaInterface != null) mediaInterface?.release()
    }

    /**
     * 里面的的onState...()其实就是setState...()，因为要可以被复写，所以参考Activity的onCreate(),onState..()的方式看着舒服一些，老铁们有何高见。
     *
     * @param state stateId
     */
    fun setState(state: Int) {
        when (state) {
            STATE_NORMAL -> onStateNormal()
            STATE_PREPARING -> onStatePreparing()
            STATE_PREPARING_PLAYING -> onStatePreparingPlaying()
            STATE_PREPARING_CHANGE_URL -> onStatePreparingChangeUrl()
            STATE_PLAYING -> onStatePlaying()
            STATE_PAUSE -> onStatePause()
            STATE_ERROR -> onStateError()
            STATE_AUTO_COMPLETE -> onStateAutoComplete()
        }
    }

    fun setScreen(screen: Int) { //特殊的个别的进入全屏的按钮在这里设置  只有setup的时候能用上
        when (screen) {
            SCREEN_NORMAL -> setScreenNormal()
            SCREEN_FULLSCREEN -> setScreenFullscreen()
            SCREEN_TINY -> setScreenTiny()
        }
    }

    open fun startVideo() {
        Log.d(TAG, "startVideo [" + this.hashCode() + "] ")
        setCurrentJzvd(this)
        try {
            val constructor: Constructor<JZMediaInterface> =
                mediaInterfaceClass?.getConstructor(Jzvd::class.java) as Constructor<JZMediaInterface>
            this.mediaInterface = constructor.newInstance(this)
        } catch (e: NoSuchMethodException) {
            e.printStackTrace()
        } catch (e: IllegalAccessException) {
            e.printStackTrace()
        } catch (e: InstantiationException) {
            e.printStackTrace()
        } catch (e: InvocationTargetException) {
            e.printStackTrace()
        }
        addTextureView()
        scanForActivity(context)?.window?.addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)
        onStatePreparing()
    }


    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        if (screen == SCREEN_FULLSCREEN || screen == SCREEN_TINY) {
            super.onMeasure(widthMeasureSpec, heightMeasureSpec)
            return
        }
        if (widthRatio != 0 && heightRatio != 0) {
            val specWidth = MeasureSpec.getSize(widthMeasureSpec)
            val specHeight = ((specWidth * heightRatio.toFloat()) / widthRatio).toInt()
            setMeasuredDimension(specWidth, specHeight)

            val childWidthMeasureSpec = MeasureSpec.makeMeasureSpec(specWidth, MeasureSpec.EXACTLY)
            val childHeightMeasureSpec =
                MeasureSpec.makeMeasureSpec(specHeight, MeasureSpec.EXACTLY)
            getChildAt(0).measure(childWidthMeasureSpec, childHeightMeasureSpec)
        } else {
            super.onMeasure(widthMeasureSpec, heightMeasureSpec)
        }
    }


    fun addTextureView() {
        Log.d(TAG, "addTextureView [" + this.hashCode() + "] ")
        if (textureView != null) textureViewContainer?.removeView(textureView)
        Log.d(
            TAG,
            "addTextureView [$mWidth==$mHeight] "
        )
        textureView = JZTextureView(context.applicationContext, mWidth, mHeight)
        textureView?.surfaceTextureListener = mediaInterface

        val layoutParams =
            LayoutParams(
                ViewGroup.LayoutParams.MATCH_PARENT,
                ViewGroup.LayoutParams.MATCH_PARENT,
                Gravity.CENTER
            )
        textureViewContainer?.addView(textureView, layoutParams)
    }

    fun clearFloatScreen() {
        showStatusBar(context)
        setRequestedOrientation(
            context, NORMAL_ORIENTATION
        )
        showSystemUI(context)

        val vg = (scanForActivity(
            context
        ))?.window?.decorView as ViewGroup
        vg.removeView(this)
        if (mediaInterface != null) mediaInterface?.release()
        CURRENT_JZVD = null
    }

    fun onVideoSizeChanged(width: Int, height: Int) {
        Log.i(TAG, "onVideoSizeChanged " + " [" + this.hashCode() + "] ")
        if (textureView != null) {
            if (videoRotation != 0) {
                textureView?.rotation = videoRotation.toFloat()
            }
            textureView?.setVideoSize(width, height)
        }
    }

    //    public void startProgressTimer() {
    //        Log.i(TAG, "startProgressTimer: " + " [" + this.hashCode() + "] ");
    //        cancelProgressTimer();
    //        UPDATE_PROGRESS_TIMER = new Timer();
    //        mProgressTimerTask = new Jzvd.ProgressTimerTask();
    //        UPDATE_PROGRESS_TIMER.schedule(mProgressTimerTask, 0, 300);
    //    }
    //    public void cancelProgressTimer() {
    //        if (UPDATE_PROGRESS_TIMER != null) {
    //            UPDATE_PROGRESS_TIMER.cancel();
    //        }
    //        if (mProgressTimerTask != null) {
    //            mProgressTimerTask.cancel();
    //        }
    //    }
    open fun onProgress(progress: Int, position: Long, duration: Long) {
        Log.d(
            TAG,
            "onProgress: progress=$progress position=$position duration=$duration"
        )
        mCurrentPosition = position
        if (!mTouchingProgressBar) {
            if (seekToManulPosition != -1) {
                if (seekToManulPosition > progress) {
                } else {
                    seekToManulPosition = -1 //这个关键帧有没有必要做
                }
            } else {
//                progressBar.setProgress(progress);
            }
        }
        //        if (position != 0) currentTimeTextView.setText(JZUtils.stringForTime(position));
//        totalTimeTextView.setText(JZUtils.stringForTime(duration));
    }

    open fun setBufferProgress(bufferProgress: Int) {
//        progressBar.setSecondaryProgress(bufferProgress);
    }


    fun getCurrentPositionWhenPlaying(): Long {
        var position: Long = 0
        if (state == STATE_PLAYING || state == STATE_PAUSE || state == STATE_PREPARING_PLAYING) {
            try {
                position = mediaInterface?.currentPosition ?: 0
            } catch (e: IllegalStateException) {
                e.printStackTrace()
                return position
            }
        }
        return position
    }

    fun getDuration(): Long {
        var duration: Long = 0
        try {
            duration = mediaInterface?.duration ?: 0
        } catch (e: Exception) {
            e.printStackTrace()
            return duration
        }
        return duration
    }

    override fun onStartTrackingTouch(seekBar: SeekBar) {
        Log.i(TAG, "bottomProgress onStartTrackingTouch [" + this.hashCode() + "] ")
        var vpdown = parent
        while (vpdown != null) {
            vpdown.requestDisallowInterceptTouchEvent(true)
            vpdown = vpdown.parent
        }
    }

    override fun onStopTrackingTouch(seekBar: SeekBar) {
        Log.i(TAG, "bottomProgress onStopTrackingTouch [" + this.hashCode() + "] ")
        var vpup = parent
        while (vpup != null) {
            vpup.requestDisallowInterceptTouchEvent(false)
            vpup = vpup.parent
        }
        if (state != STATE_PLAYING &&
            state != STATE_PAUSE
        ) return
        val time = seekBar.progress * getDuration() / 100
        seekToManulPosition = seekBar.progress
        mediaInterface?.seekTo(time)
        Log.i(TAG, "seekTo " + time + " [" + this.hashCode() + "] ")
    }

    override fun onProgressChanged(seekBar: SeekBar, progress: Int, fromUser: Boolean) {
    }

    fun cloneAJzvd(vg: ViewGroup) {
        try {
            val constructor = javaClass.getConstructor(
                Context::class.java
            ) as Constructor<Jzvd>
            val jzvd = constructor.newInstance(
                context
            )
            jzvd.id = id
            jzvd.minimumWidth = blockWidth
            jzvd.minimumHeight = blockHeight
            vg.addView(jzvd, blockIndex, blockLayoutParams)
            jzvd.setUp(jzDataSource?.cloneMe(), SCREEN_NORMAL, mediaInterfaceClass)
        } catch (e: IllegalAccessException) {
            e.printStackTrace()
        } catch (e: InstantiationException) {
            e.printStackTrace()
        } catch (e: InvocationTargetException) {
            e.printStackTrace()
        } catch (e: NoSuchMethodException) {
            e.printStackTrace()
        }
    }

    /**
     * 如果全屏或者返回全屏的视图有问题，复写这两个函数gotoScreenNormal(),根据自己布局的情况重新布局。
     */
    fun gotoFullscreen() {
        gotoFullscreenTime = System.currentTimeMillis()
        var vg = parent as ViewGroup
        jzvdContext = vg.context
        blockLayoutParams = layoutParams
        blockIndex = vg.indexOfChild(this)
        blockWidth = width
        blockHeight = height

        vg.removeView(this)
        cloneAJzvd(vg)
        CONTAINER_LIST.add(vg)
        vg = (scanForActivity(jzvdContext))?.window?.decorView as ViewGroup

        val fullLayout: ViewGroup.LayoutParams = LayoutParams(
            ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT
        )
        vg.addView(this, fullLayout)

        setScreenFullscreen()
        hideStatusBar(jzvdContext)
        setRequestedOrientation(jzvdContext, FULLSCREEN_ORIENTATION)
        hideSystemUI(jzvdContext) //华为手机和有虚拟键的手机全屏时可隐藏虚拟键 issue:1326
    }

    fun gotoNormalScreen() { //goback本质上是goto
        gobakFullscreenTime = System.currentTimeMillis() //退出全屏
        val vg = (scanForActivity(jzvdContext))?.window?.decorView as ViewGroup
        vg.removeView(this)
        CONTAINER_LIST.last.removeViewAt(blockIndex) //remove block
        CONTAINER_LIST.last.addView(
            this, blockIndex, blockLayoutParams
        )
        CONTAINER_LIST.pop()

        setScreenNormal() //这块可以放到jzvd中
        showStatusBar(jzvdContext)
        setRequestedOrientation(jzvdContext, NORMAL_ORIENTATION)
        showSystemUI(jzvdContext)
    }

    open fun setScreenNormal() { //TODO 这块不对呀，还需要改进，设置flag之后要设置ui，不设置ui这么写没意义呀
        screen = SCREEN_NORMAL
    }

    open fun setScreenFullscreen() {
        screen = SCREEN_FULLSCREEN
    }

    open fun setScreenTiny() {
        screen = SCREEN_TINY
    }


    fun onSeekComplete() {
    }


    open fun showProgressDialog(
        deltaX: Float,
        seekTime: String?, seekTimePosition: Long,
        totalTime: String?, totalTimeDuration: Long
    ) {
    }

    open fun dismissProgressDialog() {
    }

    open fun showVolumeDialog(deltaY: Float, volumePercent: Int) {
    }

    open fun dismissVolumeDialog() {
    }

    open fun showBrightnessDialog(brightnessPercent: Int) {
    }

    open fun dismissBrightnessDialog() {
    }

    fun getApplicationContext(): Context? { //这个函数必要吗
        val context = context
        if (context != null) {
            val applicationContext = context.applicationContext
            if (applicationContext != null) {
                return applicationContext
            }
        }
        return context
    }

    companion object {
        const val TAG: String = "JZVD"
        const val SCREEN_NORMAL: Int = 0
        const val SCREEN_FULLSCREEN: Int = 1
        const val SCREEN_TINY: Int = 2
        const val STATE_IDLE: Int = -1
        const val STATE_NORMAL: Int = 0
        const val STATE_PREPARING: Int = 1
        const val STATE_PREPARING_CHANGE_URL: Int = 2
        const val STATE_PREPARING_PLAYING: Int = 3
        const val STATE_PREPARED: Int = 4
        const val STATE_PLAYING: Int = 5
        const val STATE_PAUSE: Int = 6
        const val STATE_AUTO_COMPLETE: Int = 7
        const val STATE_ERROR: Int = 8
        const val VIDEO_IMAGE_DISPLAY_TYPE_ADAPTER: Int = 0 //DEFAULT
        const val VIDEO_IMAGE_DISPLAY_TYPE_FILL_PARENT: Int = 1
        const val VIDEO_IMAGE_DISPLAY_TYPE_FILL_SCROP: Int = 2
        const val VIDEO_IMAGE_DISPLAY_TYPE_ORIGINAL: Int = 3
        const val THRESHOLD: Int = 80
        var CURRENT_JZVD: Jzvd? = null
        var CONTAINER_LIST: LinkedList<ViewGroup> = LinkedList()
        var TOOL_BAR_EXIST: Boolean = true
        var FULLSCREEN_ORIENTATION: Int = ActivityInfo.SCREEN_ORIENTATION_SENSOR_LANDSCAPE
        var NORMAL_ORIENTATION: Int = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT
        var SAVE_PROGRESS: Boolean = true

        @JvmField
        var WIFI_TIP_DIALOG_SHOWED: Boolean = false
        var VIDEO_IMAGE_DISPLAY_TYPE: Int = 0
        var lastAutoFullscreenTime: Long = 0
        var ON_PLAY_PAUSE_TMP_STATE: Int = 0 //这个考虑不放到库里，去自定义
        var backUpBufferState: Int = -1
        var PROGRESS_DRAG_RATE: Float = 1f //进度条滑动阻尼系数 越大播放进度条滑动越慢
        var onAudioFocusChangeListener: OnAudioFocusChangeListener =
            object : OnAudioFocusChangeListener {
                //是否新建个class，代码更规矩，并且变量的位置也很尴尬
                override fun onAudioFocusChange(focusChange: Int) {
                    when (focusChange) {
                        AudioManager.AUDIOFOCUS_GAIN -> {}
                        AudioManager.AUDIOFOCUS_LOSS -> {
                            releaseAllVideos()
                            Log.d(TAG, "AUDIOFOCUS_LOSS [" + this.hashCode() + "]")
                        }

                        AudioManager.AUDIOFOCUS_LOSS_TRANSIENT -> {
                            try {
                                val player = CURRENT_JZVD
                                //                        if (player != null && player.state == Jzvd.STATE_PLAYING) {
//                            player.startButton.performClick();
//                        }
                            } catch (e: IllegalStateException) {
                                e.printStackTrace()
                            }
                            Log.d(TAG, "AUDIOFOCUS_LOSS_TRANSIENT [" + this.hashCode() + "]")
                        }

                        AudioManager.AUDIOFOCUS_LOSS_TRANSIENT_CAN_DUCK -> {}
                    }
                }
            }

        /**
         * 增加准备状态逻辑
         */
        fun goOnPlayOnResume() {
            if (CURRENT_JZVD != null) {
//            if (CURRENT_JZVD.state == Jzvd.STATE_PAUSE) {
//                if (ON_PLAY_PAUSE_TMP_STATE == STATE_PAUSE) {
//                    CURRENT_JZVD.onStatePause();
//                    CURRENT_JZVD.mediaInterface.pause();
//                } else {
//                    CURRENT_JZVD.onStatePlaying();
                CURRENT_JZVD?.mediaInterface?.start()
                //                }
//                ON_PLAY_PAUSE_TMP_STATE = 0;
//            } else if (CURRENT_JZVD.state == Jzvd.STATE_PREPARING) {
//                //准备状态暂停后的
//                CURRENT_JZVD.startVideo();
//            }
//            if (CURRENT_JZVD.screen == Jzvd.SCREEN_FULLSCREEN) {
//                JZUtils.hideStatusBar(CURRENT_JZVD.jzvdContext);
//                JZUtils.hideSystemUI(CURRENT_JZVD.jzvdContext);
//            }
            }
        }

        /**
         * 增加准备状态逻辑
         */
        fun goOnPlayOnPause() {
            if (CURRENT_JZVD != null) {
//            if (CURRENT_JZVD.state ==Jzvd.STATE_AUTO_COMPLETE ||
//                    CURRENT_JZVD.state == Jzvd.STATE_NORMAL ||
//                    CURRENT_JZVD.state == Jzvd.STATE_ERROR) {
//                Jzvd.releaseAllVideos();
//            } else if (CURRENT_JZVD.state ==Jzvd.STATE_PREPARING) {
//                //准备状态暂停的逻辑
//               Jzvd.setCurrentJzvd(CURRENT_JZVD);
//                CURRENT_JZVD.state = STATE_PREPARING;
//            } else {
//                ON_PLAY_PAUSE_TMP_STATE = CURRENT_JZVD.state;
//                CURRENT_JZVD.onStatePause();
                CURRENT_JZVD?.mediaInterface?.pause()
                //            }
            }
        }

        //    public static void startFullscreenDirectly(Context context, Class _class, String url, String title) {
        //        startFullscreenDirectly(context, _class, new JZDataSource(url, title));
        //    }
        //    public static void startFullscreenDirectly(Context context, Class _class, JZDataSource jzDataSource) {
        //        JZUtils.hideStatusBar(context);
        //        JZUtils.setRequestedOrientation(context, FULLSCREEN_ORIENTATION);
        //        JZUtils.hideSystemUI(context);
        //
        //        ViewGroup vp = (ViewGroup) JZUtils.scanForActivity(context).getWindow().getDecorView();
        //        try {
        //            Constructor<Jzvd> constructor = _class.getConstructor(Context.class);
        //            final Jzvd jzvd = constructor.newInstance(context);
        //            FrameLayout.LayoutParams lp = new FrameLayout.LayoutParams(
        //                    ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        //            vp.addView(jzvd, lp);
        //            jzvd.setUp(jzDataSource, JzvdStd.SCREEN_FULLSCREEN);
        //            jzvd.startVideo();
        //        } catch (Exception e) {
        //            e.printStackTrace();
        //        }
        //    }
        fun releaseAllVideos() {
            Log.d(TAG, "releaseAllVideos")
            if (CURRENT_JZVD != null) {
                CURRENT_JZVD?.reset()
                CURRENT_JZVD = null
            }
            CONTAINER_LIST.clear()
        }

        fun backPress(): Boolean {
            Log.i(TAG, "backPress")
            if (!CONTAINER_LIST.isEmpty() && CURRENT_JZVD != null) { //判断条件，因为当前所有goBack都是回到普通窗口
                CURRENT_JZVD?.gotoNormalScreen()
                return true
            } else if (CONTAINER_LIST.isEmpty() && CURRENT_JZVD != null && CURRENT_JZVD?.screen != SCREEN_NORMAL) { //退出直接进入的全屏
                CURRENT_JZVD?.clearFloatScreen()
                return true
            }
            return false
        }

        fun setCurrentJzvd(jzvd: Jzvd?) {
            if (CURRENT_JZVD != null) CURRENT_JZVD?.reset()
            CURRENT_JZVD = jzvd
        }
    }
}
