package com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd

import android.annotation.SuppressLint
import android.app.Dialog
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.net.ConnectivityManager
import android.util.AttributeSet
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.View.OnClickListener
import android.view.Window
import android.view.WindowManager
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.ProgressBar
import android.widget.SeekBar
import android.widget.TextView
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.bussiness.module_report.track.ReportTrackerManager
import com.halomobi.ssp.bussiness.module_video.otherads.cn.jzvd.JZUtils.isWifiConnected
import com.halomobi.ssp.model.request.bean.AdBean
import com.ssp.sdk.R
import java.text.SimpleDateFormat
import java.util.Date


class JzvdStd : Jzvd {
    var backButton: ImageView? = null
    var loadingProgressBar: ProgressBar? = null
    var titleTextView: TextView? = null
    var videoCurrentTime: TextView? = null
    var clarity: TextView? = null
    var mRetryBtn: TextView? = null
    var volume: ImageView? = null
    private var mAd: AdBean? = null
    private var isVolumn = true
    var battertReceiver: BroadcastReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            val action = intent.action
            if (Intent.ACTION_BATTERY_CHANGED == action) {
                val level = intent.getIntExtra("level", 0)
                val scale = intent.getIntExtra("scale", 100)
                LAST_GET_BATTERYLEVEL_PERCENT = level * 100 / scale
                setBatteryLevel()
                try {
                    jzvdContext?.unregisterReceiver(this)
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }
        }
    }
    protected var mProgressDialog: Dialog? = null
    protected var mDialogProgressBar: ProgressBar? = null
    protected var mDialogSeekTime: TextView? = null
    protected var mDialogTotalTime: TextView? = null
    protected var mDialogIcon: ImageView? = null
    protected var mVolumeDialog: Dialog? = null
    protected var mDialogVolumeProgressBar: ProgressBar? = null
    protected var mDialogVolumeTextView: TextView? = null
    protected var mDialogVolumeImageView: ImageView? = null
    protected var mBrightnessDialog: Dialog? = null
    protected var mDialogBrightnessProgressBar: ProgressBar? = null
    protected var mDialogBrightnessTextView: TextView? = null
    protected var mIsWifi: Boolean = false


    var wifiReceiver: BroadcastReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            if (ConnectivityManager.CONNECTIVITY_ACTION == intent.action) {
                val isWifi = isWifiConnected(context)
                if (mIsWifi == isWifi) return
                mIsWifi = isWifi
                if (!mIsWifi && !WIFI_TIP_DIALOG_SHOWED && state == STATE_PLAYING) {
                }
            }
        }
    }


    constructor(context: Context) : super(context)

    constructor(context: Context, width: Int, height: Int) : super(context, width, height)

    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs)

    override fun init(context: Context) {
        super.init(context)
        titleTextView = findViewById(R.id.title)
        backButton = findViewById(R.id.back)
        loadingProgressBar = findViewById(R.id.loading)
        videoCurrentTime = findViewById(R.id.video_current_time)
        clarity = findViewById(R.id.clarity)
        mRetryBtn = findViewById(R.id.retry_btn)
        volume = findViewById(R.id.hj_iv_volume)
        if (titleTextView == null) {
            titleTextView = TextView(context)
        }
        if (backButton == null) {
            backButton = ImageView(context)
        }

        if (loadingProgressBar == null) {
            loadingProgressBar = ProgressBar(context)
        }
        if (videoCurrentTime == null) {
            videoCurrentTime = TextView(context)
        }

        if (clarity == null) {
            clarity = TextView(context)
        }
        if (mRetryBtn == null) {
            mRetryBtn = TextView(context)
        }
        (volume as ImageView).setOnClickListener {
            if (isVolumn) {
                mediaInterface?.setVolume(0f, 0f)
                reportTracker(ConstantPool.TrackerType.MUTE_TRACKER)
                (volume as ImageView).setImageResource(R.drawable.hj_mute)
                isVolumn = false
            } else {
                mediaInterface?.setVolume(1f, 1f)
                reportTracker(ConstantPool.TrackerType.UNMUTE_TRACKER)
                (volume as ImageView).setImageResource(R.drawable.hj_unmute)
                isVolumn = true
            }
        }
    }

    override fun setUp(jzDataSource: JZDataSource?, screen: Int, mediaInterfaceClass: Class<*>?) {
        if ((System.currentTimeMillis() - gobakFullscreenTime) < 200) {
            return
        }

        if ((System.currentTimeMillis() - gotoFullscreenTime) < 200) {
            return
        }


        super.setUp(jzDataSource, screen, mediaInterfaceClass)
        titleTextView?.text = jzDataSource?.title
        setScreen(screen)
    }
     //设置广告对象
    fun setAdBean(ad:AdBean?){
        mAd=ad
    }

    override fun changeUrl(jzDataSource: JZDataSource?, seekToInAdvance: Long) {
        super.changeUrl(jzDataSource, seekToInAdvance)
        titleTextView?.text = jzDataSource?.title
    }

    override val layoutId: Int
        get() = R.layout.jz_layout_std

    override fun onStateNormal() {
        super.onStateNormal()
        changeUiToNormal()
    }

    override fun onStatePreparing() {
        super.onStatePreparing()
        changeUiToPreparing()
    }

    override fun onStatePreparingPlaying() {
        super.onStatePreparingPlaying()
        changeUIToPreparingPlaying()
    }

    override fun onStatePreparingChangeUrl() {
        super.onStatePreparingChangeUrl()
        changeUIToPreparingChangeUrl()
    }

    override fun onStatePlaying() {
        super.onStatePlaying()
        reportTracker(ConstantPool.TrackerType.DISPLAY)
        reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_0_TRACKER)
        changeUiToPlayingClear()
    }

    override fun onStatePause() {
        reportTracker(ConstantPool.TrackerType.VIDEO_PAUSE_TRACKER)
        super.onStatePause()
        changeUiToPauseShow()
    }

    override fun onStateError() {
        super.onStateError()
        changeUiToError()
    }

    override fun onStateAutoComplete() {
        super.onStateAutoComplete()
        changeUiToComplete()
    }

    override fun startVideo() {
        super.startVideo()
        registerWifiListener(getApplicationContext())
    }


    override fun setScreenNormal() {
        super.setScreenNormal()
        backButton?.visibility = GONE
        clarity?.visibility = GONE
    }

    override fun setScreenFullscreen() {
        super.setScreenFullscreen()
        //进入全屏之后要保证原来的播放状态和ui状态不变，改变个别的ui
        backButton?.visibility = VISIBLE
        if (jzDataSource?.urlsMap?.size == 1) {
            clarity?.visibility = GONE
        } else {
            clarity?.text = jzDataSource?.currentKey.toString()
            clarity?.visibility = VISIBLE
        }
        setSystemTimeAndBattery()
    }

    override fun setScreenTiny() {
        super.setScreenTiny()
        setAllControlsVisiblity(
            INVISIBLE, INVISIBLE, INVISIBLE,
            INVISIBLE, INVISIBLE, INVISIBLE, INVISIBLE
        )
        clarity?.visibility = GONE
    }


    override fun onStartTrackingTouch(seekBar: SeekBar) {
        super.onStartTrackingTouch(seekBar)
    }

    override fun onStopTrackingTouch(seekBar: SeekBar) {
        super.onStopTrackingTouch(seekBar)
    }


    fun setSystemTimeAndBattery() {
        val dateFormater = SimpleDateFormat("HH:mm")
        val date = Date()
        videoCurrentTime?.text = dateFormater.format(date)
        if ((System.currentTimeMillis() - LAST_GET_BATTERYLEVEL_TIME) > 30000) {
            LAST_GET_BATTERYLEVEL_TIME = System.currentTimeMillis()
            jzvdContext?.registerReceiver(
                battertReceiver,
                IntentFilter(Intent.ACTION_BATTERY_CHANGED)
            )
        } else {
            setBatteryLevel()
        }
    }

    fun setBatteryLevel() {
    }


    override fun onProgress(progress: Int, position: Long, duration: Long) {
        if (mAd != null) {
            if (progress == 0) {
                reportTracker(ConstantPool.TrackerType.VIDEO_START_TRACKER)
            } else if (mAd?.is25Report != true && progress > 22 && progress < 28) {
                mAd?.is25Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_1_TRACKER)
            } else if (mAd?.is50Report != true && progress > 47 && progress < 53) {
                mAd?.is50Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_2_TRACKER)
            } else if (mAd?.is75Report != true && progress > 72 && progress < 78) {
                mAd?.is75Report = true
                reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_3_TRACKER)
            } else if (progress >= 99) {
                reportTracker(ConstantPool.TrackerType.VIDEO_COMPLETE_TRACKER)
            }
        }
    }

    override fun setBufferProgress(bufferProgress: Int) {
        super.setBufferProgress(bufferProgress)
    }

    fun changeUiToNormal() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                VISIBLE, INVISIBLE, VISIBLE,
                INVISIBLE, VISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun changeUiToPreparing() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                INVISIBLE, INVISIBLE, INVISIBLE,
                VISIBLE, VISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun changeUIToPreparingPlaying() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                VISIBLE, VISIBLE, INVISIBLE,
                VISIBLE, INVISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun changeUIToPreparingChangeUrl() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                INVISIBLE, INVISIBLE, INVISIBLE,
                VISIBLE, VISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }


    fun changeUiToPlayingClear() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                INVISIBLE, INVISIBLE, INVISIBLE,
                INVISIBLE, INVISIBLE, VISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun changeUiToPauseShow() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                VISIBLE, VISIBLE, VISIBLE,
                INVISIBLE, INVISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }


    fun changeUiToComplete() {
        when (screen) {
            SCREEN_NORMAL, SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                VISIBLE, INVISIBLE, VISIBLE,
                INVISIBLE, VISIBLE, INVISIBLE, INVISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun changeUiToError() {
        when (screen) {
            SCREEN_NORMAL -> setAllControlsVisiblity(
                INVISIBLE, INVISIBLE, VISIBLE,
                INVISIBLE, INVISIBLE, INVISIBLE, VISIBLE
            )

            SCREEN_FULLSCREEN -> setAllControlsVisiblity(
                VISIBLE, INVISIBLE, VISIBLE,
                INVISIBLE, INVISIBLE, INVISIBLE, VISIBLE
            )

            SCREEN_TINY -> {}
        }
    }

    fun setAllControlsVisiblity(
        topCon: Int, bottomCon: Int, startBtn: Int, loadingPro: Int,
        posterImg: Int, bottomPro: Int, retryLayout: Int
    ) {
        loadingProgressBar?.visibility = loadingPro
    }

    @SuppressLint("SetTextI18n")
    override fun showProgressDialog(
        deltaX: Float,
        seekTime: String?,
        seekTimePosition: Long,
        totalTime: String?,
        totalTimeDuration: Long
    ) {
        super.showProgressDialog(deltaX, seekTime, seekTimePosition, totalTime, totalTimeDuration)
        if (mProgressDialog == null) {
            val localView =
                LayoutInflater.from(jzvdContext).inflate(R.layout.jz_dialog_progress, null)
            mDialogProgressBar = localView.findViewById(R.id.duration_progressbar)
            mDialogSeekTime = localView.findViewById(R.id.tv_current)
            mDialogTotalTime = localView.findViewById(R.id.tv_duration)
            mDialogIcon = localView.findViewById(R.id.duration_image_tip)
            mProgressDialog = createDialogWithView(localView)
        }
        if (mProgressDialog?.isShowing==false) {
            mProgressDialog?.show()
        }

        mDialogSeekTime?.text = seekTime
        mDialogTotalTime?.text = " / $totalTime"
        mDialogProgressBar?.progress =
            if (totalTimeDuration <= 0) 0 else (seekTimePosition * 100 / totalTimeDuration).toInt()
        if (deltaX > 0) {
            mDialogIcon?.setBackgroundResource(R.drawable.jz_forward_icon)
        } else {
            mDialogIcon?.setBackgroundResource(R.drawable.jz_backward_icon)
        }
    }

    override fun dismissProgressDialog() {
        super.dismissProgressDialog()
        if (mProgressDialog != null) {
            mProgressDialog?.dismiss()
        }
    }

    @SuppressLint("SetTextI18n")
    override fun showVolumeDialog(deltaY: Float, volumePercent: Int) {
        var volumePercent = volumePercent
        super.showVolumeDialog(deltaY, volumePercent)
        if (mVolumeDialog == null) {
            val localView =
                LayoutInflater.from(jzvdContext).inflate(R.layout.jz_dialog_volume, null)
            mDialogVolumeImageView = localView.findViewById(R.id.volume_image_tip)
            mDialogVolumeTextView = localView.findViewById(R.id.tv_volume)
            mDialogVolumeProgressBar = localView.findViewById(R.id.volume_progressbar)
            mVolumeDialog = createDialogWithView(localView)
        }
        if (mVolumeDialog?.isShowing==false) {
            mVolumeDialog?.show()
        }
        if (volumePercent <= 0) {
            mDialogVolumeImageView?.setBackgroundResource(R.drawable.jz_close_volume)
        } else {
            mDialogVolumeImageView?.setBackgroundResource(R.drawable.jz_add_volume)
        }
        if (volumePercent > 100) {
            volumePercent = 100
        } else if (volumePercent < 0) {
            volumePercent = 0
        }
        mDialogVolumeTextView?.text = "$volumePercent%"
        mDialogVolumeProgressBar?.progress = volumePercent
    }

    override fun dismissVolumeDialog() {
        super.dismissVolumeDialog()
        if (mVolumeDialog != null) {
            mVolumeDialog?.dismiss()
        }
    }

    @SuppressLint("SetTextI18n")
    override fun showBrightnessDialog(brightnessPercent: Int) {
        var brightnessPercent = brightnessPercent
        super.showBrightnessDialog(brightnessPercent)
        if (mBrightnessDialog == null) {
            val localView =
                LayoutInflater.from(jzvdContext).inflate(R.layout.jz_dialog_brightness, null)
            mDialogBrightnessTextView = localView.findViewById(R.id.tv_brightness)
            mDialogBrightnessProgressBar = localView.findViewById(R.id.brightness_progressbar)
            mBrightnessDialog = createDialogWithView(localView)
        }
        if (mBrightnessDialog?.isShowing==false) {
            mBrightnessDialog?.show()
        }
        if (brightnessPercent > 100) {
            brightnessPercent = 100
        } else if (brightnessPercent < 0) {
            brightnessPercent = 0
        }
        mDialogBrightnessTextView?.text = "$brightnessPercent%"
        mDialogBrightnessProgressBar?.progress = brightnessPercent
    }

    override fun dismissBrightnessDialog() {
        super.dismissBrightnessDialog()
        if (mBrightnessDialog != null) {
            mBrightnessDialog?.dismiss()
        }
    }

    fun createDialogWithView(localView: View): Dialog? {
        val dialog = jzvdContext?.let { Dialog(it, R.style.jz_style_dialog_progress) }
        dialog?.setContentView(localView)
        val window = dialog?.window
        window?.addFlags(Window.FEATURE_ACTION_BAR)
        window?.addFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL)
        window?.addFlags(WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE)
        window?.setLayout(-2, -2)
        val localLayoutParams = window?.attributes
        localLayoutParams?.gravity = Gravity.CENTER
        window?.attributes = localLayoutParams
        return dialog
    }


    override fun onCompletion() {
        reportTracker(ConstantPool.TrackerType.VIDEO_PLAYING_4_TRACKER)
        reportTracker(ConstantPool.TrackerType.VIDEO_LOADED_TRACKER)
        super.onCompletion()
    }

    override fun reset() {
        super.reset()
        unregisterWifiListener(getApplicationContext())
    }


    fun registerWifiListener(context: Context?) {
        if (context == null) return
        mIsWifi = isWifiConnected(context)
        val intentFilter = IntentFilter(ConnectivityManager.CONNECTIVITY_ACTION)
        context.registerReceiver(wifiReceiver, intentFilter)
    }

    fun unregisterWifiListener(context: Context?) {
        if (context == null) return
        try {
            context.unregisterReceiver(wifiReceiver)
        } catch (e: IllegalArgumentException) {
            e.printStackTrace()
        }
    }


    companion object {
        var LAST_GET_BATTERYLEVEL_TIME: Long = 0
        var LAST_GET_BATTERYLEVEL_PERCENT: Int = 70
    }

    private fun reportTracker(type: Int) {
        try {
            if (mAd != null) {
                mAd?.getTracks(type)?.let { ReportTrackerManager.instance?.reportTrack(it) }
                mAd?.trackerGroup?.remove(type)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

}
