package com.halomobi.ssp.framework.listener

import com.halomobi.ssp.model.request.bean.AdBean


/**
 * 广告各种状态的回调
 *
 */
interface AdStateChangListener {
    /**
     * 广告加载前准备
     */
    fun onStart()

    /**
     * 广告加载失败
     *
     * @param errorMsg  错误信息
     * @param errorCode 错误码
     */
    fun onAdError(errorMsg: String?, errorCode: Int)

    /**
     * 广告返回
     *
     * @param adInfo 广告对象
     */
    fun onAdReach(adInfo: AdBean?)

    /**
     * 原生类型广告返回
     *
     * @param adInfoList 广告集合对象
     */
    fun onNativeAdReach(adInfoList: List<AdBean?>?)

//    /**
//     * 浮窗广告返回
//     */
//    fun onFloatAdReach(adInfoList: List<AdBean?>?)
}
