package com.halomobi.ssp.framework.schedule

import com.halomobi.ssp.framework.schedule.ThreadManager.ThreadPoolProxy


class TaskManager {
    private val mTaskQueue =
        HashMap<String, ITask>()
    private val mThreadPoolProxy: ThreadPoolProxy =
        ThreadManager.getSinglePool(hashCode().toString() + "")

    /**
     * 添加任务到队列
     *
     * @param task 任务
     */
    @Synchronized
    fun addTask(task: ITask) {
        // 根据Task启动模式,控制添加方式.
        if (task.launchMode == ITask.LaunchMode.REPLACE_OLD) {
            val lastTAsk = mTaskQueue.put(task.name.toString(), task)
            mThreadPoolProxy.cancel(lastTAsk)
        }
        mThreadPoolProxy.execute(task)
    }

    fun removeAllTask() {
        mThreadPoolProxy.shutdown()
        mTaskQueue.clear()
    }

    fun removeTaskByName(name: String?) {
        mThreadPoolProxy.cancel(mTaskQueue.remove(name))
    }
}
