package com.halomobi.ssp.model.net.absnet

import com.halomobi.ssp.base.common.ConfigPool
import com.halomobi.ssp.base.common.ConstantPool
import com.halomobi.ssp.base.utils.Utils
import com.halomobi.ssp.bussiness.module_download.DownloadProcessor
import com.halomobi.ssp.framework.schedule.TaskManager
import com.halomobi.ssp.framework.schedule.ThreadManager.downloadPool
import com.halomobi.ssp.framework.schedule.ThreadManager.longPool
import com.halomobi.ssp.framework.schedule.ThreadManager.requestAdPool
import com.halomobi.ssp.framework.schedule.ThreadManager.singlePool
import com.halomobi.ssp.model.request.adtask.RequestAdProcessor


abstract class AbsNetProcessor : NetTaskListener {
//    private var mTaskManager: TaskManager? = null

    protected abstract fun createNetTask(): AbsNetTask

//    fun setNetTaskManager(manager: TaskManager?) {
//        mTaskManager = manager
//    }

    open fun process() {
        val netTask = createNetTask()
        netTask.setListener(this)
//        // 默认是自启动模式.
//        if (mTaskManager != null) {
//            mTaskManager?.addTask(netTask)
//            return
//        }

        if (this is DownloadProcessor) {
            downloadPool.execute(netTask)
            return
        }

        if (this is RequestAdProcessor) {
            if (ConfigPool.AdShowTypeName == ConstantPool.AdType.SPLASH.adName) {
                if (Utils.isDelayed) {
                    singlePool.execute {
                        Thread.sleep(1000) // 延迟1秒等oaid获取到
                        requestAdPool.execute(netTask)
                    }
                    Utils.isDelayed=false
                } else {
                    requestAdPool.execute(netTask)
                }
            } else {
                requestAdPool.execute(netTask)
            }
            return
        }
        longPool.execute(netTask)
    }
}
