package com.halomobi.ssp.model.net.absnet

import com.halomobi.ssp.model.net.http.HttpResult


interface NetTaskListener {
    /**
     * 获得服务器返回数据(可能是正确数据,也可能是错误数据,这里不做检验)
     */
    fun onDataReceived(result: HttpResult?)

    /**
     * 返回错误
     *
     * @param eroMsg  错误信息
     * @param eroCode 错误码
     */
    fun onErrorReceived(eroMsg: String?, eroCode: Int)

    /**
     * 网络异常(HTTP返回码不为200时,均认为网络异常)
     */
    fun onNetworkError()
}