package com.halomobi.ssp.model.request.adtask

import com.halomobi.ssp.framework.listener.AdStateChangListener
import com.halomobi.ssp.model.request.bean.AdParameter


class RequestAdManager private constructor() {
    /**
     * 请求广告
     *
     * @param adParameter 广告数据对象
     * @param listener    回调Listener
     */
    fun requestAd(adParameter: AdParameter?, listener: AdStateChangListener?) {
        RequestAdProcessor(adParameter, listener).process()
    }

    companion object {
        private var mInstance: RequestAdManager? = null

        @JvmStatic
        @get:Synchronized
        val instance: RequestAdManager?
            get() {
                if (mInstance == null) {
                    mInstance = RequestAdManager()
                }
                return mInstance
            }
    }
}
