package com.halomobi.ssp.model.request.adtask

import com.halomobi.ssp.framework.schedule.ITask.LaunchMode
import com.halomobi.ssp.model.net.absnet.AbsNetTask
import com.halomobi.ssp.model.request.bean.AdParameter
import com.halomobi.ssp.model.request.bean.AdRequest.Companion.getParams
import com.halomobi.ssp.model.request.config.HttpUrlSetting
import java.net.HttpURLConnection


/**
 * 广告加载任务
 */
internal class RequestAdTask(private val parameter: AdParameter?) : AbsNetTask(ReqType.Post) {

    override val entity: ByteArray?
        get() = getParams(parameter)

    override val url: String
        get() = HttpUrlSetting.requestAdUrl

    override fun onAddHeaders(urlConnection: HttpURLConnection?) {

    }

    override val launchMode: LaunchMode
        get() =  LaunchMode.REPLACE_OLD


    override val name: String
        get() = javaClass.simpleName + "  :  " + parameter?.adSlotId


}
