package com.halomobi.ssp.model.request.iptask

import android.annotation.SuppressLint
import com.halomobi.ssp.base.utils.LogUtils.d
import com.halomobi.ssp.base.utils.Utils.sp
import com.halomobi.ssp.model.net.absnet.AbsNetProcessor
import com.halomobi.ssp.model.net.absnet.AbsNetTask
import com.halomobi.ssp.model.net.http.HttpResult
import org.json.JSONException
import org.json.JSONObject

internal class RequestIpProcessor : AbsNetProcessor() {
    private val mPreferences = sp

    override fun createNetTask(): AbsNetTask {
        return RequestIpTask()
    }

    @SuppressLint("UseKtx")
    override fun onDataReceived(result: HttpResult?) {
        try {
            val `object` = result?.string?.let { JSONObject(it) }
            val hostData = `object`?.optJSONObject("data")
            if (hostData != null) {
                val ipAddress = hostData.optString("ip")
                mPreferences?.edit()?.putString(RequestIpManager.IP_ADDRESS, ipAddress)?.apply()
            }
        } catch (e: JSONException) {
            e.printStackTrace()
        }
    }

    override fun onErrorReceived(eroMsg: String?, eroCode: Int) {
        d("onErrorReceived--eroMsg:$eroMsg--eroCode:$eroCode")
    }

    override fun onNetworkError() {
        d("onNetworkError")
    }

    override fun process() {
        super.process()
    }

}
